// gc::bit::copy::bottom
//   coded by zoro (悵)
// 1997-11-12 write off, checked
// 1999-02-01 changed for ai15, checked
// 2007-06-21 to .cc using mactocc
//      06-25 checked on litle-endian
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBit_bottomin(dword addrdst, word widthdst, dword addrsrc, word widthsrc
, dword addrrgn, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword toprgn;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;
  word slcount;

dmesg("bottomin\n");
  xiz= addrdst;
  xbc= addrsrc;
  xde= addrrgn;
  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= 0;
  _wa-= iy;
  toppos= hl;
  _hl= (dword)-1;
  _hl+= m_word(xde+2); //rgn.y
  _hl+= m_word(xde+6); //rgn.h
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= hl;
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _hl+= p_dsty;
  xhl= (short)xhl*(short)widthdst;
  xix+= xhl;
  _wa&= 7;
  if((word)wa==0) goto bb8start;
bbstart:
  xiy-= 1;
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  xde= xde+12;
  xbc&= 0x0ffff;
  _hl= 0;
bbstartseek:
  _bc= m_word(xde+2);
  _hl+= 1;
  _bc+= bc;
  _bc+= bc;
  xde+= xbc;
  if((word)hl<m_word(xde)) goto bbstartseek; //somehow tricky
  slcount= hl;
  goto bbblkseek;
bb8start:
  topsrc= xiy;
  topdst= xix;
  xde= xde+12;
  xbc&= 0x0ffff;
  _hl= 0;
bb8startseek:
  _bc= m_word(xde+2);
  _hl+= 1;
  _bc+= bc;
  _bc+= bc;
  xde+= xbc;
  if((word)hl<m_word(xde)) goto bb8startseek; //somehow tricky
  slcount= hl;
  goto bb8blkseek;
// bit copy bottom shifted
bbxtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= iz; //tailmask
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto bbyloopex;
bbyloop:
  xiy-= nextsrc;
  xix-= nextdst;
bbyloopin:
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifdef __BIG_ENDIAN__
  e= (byte)xbc;
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= qwa; //headmask
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _hl= qde; //xcount
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl<=0) goto bbxloopex;
bbxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xbc;
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl>0) goto bbxloop;
bbxloopex:
  if((short)hl<0) goto bbxtailword;
  xbc^= m_dword(xix);
  xbc&= xiz; //tailmask
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto bbyloop;
bbyloopex:
  blkcount-= 1;
  if(blkcount==0) goto bbblknext;
bbblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
bbblkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_bittable;
  if((word)hl<17) goto bboneword;
  if((word)hl>=25) goto bbmulti;
  if(c>=8) goto bboneword1;
bbmulti:
  c+= c;
  _bc= m_word(xde+(char)c);
  qwa= bc;
  _hl-= 1;
#ifdef __BIG_ENDIAN__
  xiz= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xiz= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  qde= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc+= hl;
  _bc+= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc+= hl;
  _bc-= 2;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto bbyloopin;
bboneword1:
  xde= xde-16; //somehow tricky
  xix+= 1;
  xiy+= 1;
bboneword:
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl+= hl;
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
bboneyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= iz; //masksrc
  m_word(xix)^= bc;
  xiy-= xhl;
  xix-= xde;
  qwa--; if(qwa!=0) goto bboneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto bbblkloop;
bbblknext:
//̃XCX
  slcount-= 1;
  if((short)slcount<=0) goto bbepilogue;
  xde= toprgn;
  _bc= m_word(xde);
  if((short)m_word(xde-4)>=0) goto bbblkexist;
  slcount-= 1;
  xde-= 4; _bc+= m_word(xde);
bbblkexist:
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc; //bc͕
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
bbblkseek:
  xde-= 4; if((short)m_word(xde)>=0) goto bbblkseek;
  toprgn= xde;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  yheight= bc;
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkcount= hl;
  _hl= toppos;
  goto bbblkloopin;
// bit copy forward aligned
bb8multi:
  xde= gcBit_bit8table;
  c+= c;
  _wa= m_word(xde+(char)c);
  _hl-= 1;
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _bc= m_word(xde+(char)c);
  qbc= bc;
  _hl= (word)hl>>(3+15)%16+1;
  _hl&= 0xfffe;
  _iz= widthsrc;
  _iz+= hl;
  if(xiz&0x08000) xiz|= 0xffff0000; else xiz&= 0x0ffff;
  _de= widthdst;
  _de+= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _hl= (word)hl>>(1+15)%16+1;
  _hl-= 1;
  _bc= yheight;
  qhl= bc;
  dmesg("%d+%d < %d+%d %04x(%d)%04x x%d\n", xix, xde, xiy, xiz, wa, hl, qbc, qhl);
bb8yloop:
  _bc= (mem= xiy,xiy+= 2,m_word(mem));
  _bc^= m_word(xix);
  _bc&= wa; //headmask
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _bc= hl; //xcount
  do { m_word(xix)= m_word(xiy);
       xix+= 2; xiy+= 2; } while(--_bc, (word)bc);
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= qbc; //tailmask
  m_word(xix)^= bc;
  xiy-= xiz;
  xix-= xde;
  qhl--; if(qhl!=0) goto bb8yloop;
  qwa-= 1;
  if(qwa==0) goto bb8blknext;
bb8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe
bb8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=41) goto bb8multi;
  if((word)hl<33) goto bb8blkword;
  if(c<8) goto bb8multi;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
bb8twoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
bb8twoyloop:
  xbc= m_dword(xiy);
  xbc^= m_dword(xix);
  xbc&= xiz; //mask
  m_dword(xix)^= xbc;
  xiy-= xhl;
  xix-= xde;
  _wa--; if((word)wa!=0) goto bb8twoyloop;
  qwa-= 1;
  if(qwa!=0) goto bb8blkloop;
  goto bb8blknext;
bb8blkword:
  if((word)hl<17) goto bb8oneword;
  if((word)hl>=25) goto bb8twoword;
  if(c<8) goto bb8twoword;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
bb8oneword:
  xde= gcBit_bittable;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
bb8oneyloop:
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= iz; //mask
  m_word(xix)^= bc;
  xiy-= xhl;
  xix-= xde;
  _wa--; if((word)wa!=0) goto bb8oneyloop;
  qwa-= 1;
  if(qwa!=0) goto bb8blkloop;
bb8blknext:
//̃XCX
  slcount-= 1;
  if((short)slcount<=0) goto bbepilogue;
  xde= toprgn;
  _bc= m_word(xde);
  if((short)m_word(xde-4)>=0) goto bb8blkexist;
  slcount-= 1;
  xde-= 4; _bc+= m_word(xde);
bb8blkexist:
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc; //bc͕
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
bb8blkseek:
  xde-= 4; if((short)m_word(xde)>=0) goto bb8blkseek;
  toprgn= xde;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  yheight= bc;
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  qwa= hl;
  _hl= toppos;
  goto bb8blkloopin;
bbepilogue:
  _hl= 1;
  return(short)hl;
};
