// gc::bit::fill
//   coded by zoro (悵)
// 1997-11-15 write off, checked
// 2007-06-27 from fill.cc
//      07-04 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitClear( gcBit* dst, gcRgn* rgn, short p_dstx, short p_dsty)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  byte c;
  byte qh;

  word xposition;
  word yheight;
  word toppos;
  dword widthdst;
  dword topdst;
  dword blkrgn;
  dword blkdst;

  xwa= (dword)dst;
//<assert object dst>
  xde= (dword)rgn;
//<assert object rgn>
  if(m_word(xde+8)!=0) goto frerr;
  xiz= xwa;
  _hl= m_word(xiz+2);
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  widthdst= xhl; //widthdst
  xiz+= 4;
  if(m_word(xiz-4)==0) goto frincdst;
  xiz= m_dword(xiz);
frincdst:
  _ix= p_dstx;
  _ix+= m_word(xde); //rgn.x
  _hl= 0x000f;
  _hl&= ix;
  toppos= hl;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz;
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  qwa= bc;
  xde= xde+16;
  goto frblkloopin;
frblkword:
  if((word)hl<17) goto froneword;
  if((word)hl>=25) goto frtwoword;
  if(c<8) goto frtwoword;
  c-= 8;
  _hl-= 8;
  xix+= 1;
froneword:
  xde= gcBit_bit8table;
  _hl+= hl;
  _iz= m_word(xde+(short)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _iz= ~iz;
  xde= widthdst;
  _wa= yheight;
froneyloop:
  m_word(xix)&= iz;
  xix+= xde;
  _wa--; if((word)wa!=0) goto froneyloop;
  qwa-= 1;
  if(qwa==0) goto frblknext;
frblkloop:
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
frblkloopin:
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc>>= (3+15)%16+1;
  xix+= xbc;
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=321) goto frmulti;
  if((word)hl>=41) goto frfast;
  if((word)hl<33) goto frblkword;
  if(c<8) goto frfast;
  c-= 8;
  _hl-= 8;
  xix+= 1;
frtwoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  xiz= ~xiz;
  xde= widthdst;
  _wa= yheight;
frtwoyloop:
  m_dword(xix)&= xiz;
  xix+= xde;
  _wa--; if((word)wa!=0) goto frtwoyloop;
  qwa-= 1;
  if(qwa!=0) goto frblkloop;
frblknext:
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto frepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto frblkexist;
  yheight+= bc;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
frblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  qwa= hl;
  _hl= toppos;
  goto frblkloopin;
frepilogue:
  _hl= 1;
  return(short)hl;
frfast:
//hl<=320
  xde= gcBit_not8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto frfword;
frfdword:
// hl<320AŌ̓_u[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16;
#else
  xiy&= 0x0ffff;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz&= 0xffff;
#else
  xiz= xiz<<16;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= frfdyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  xhl= widthdst;
  c+= c;
  qh= c;
  _wa= yheight;
  xbc= 0;
frfdxloop:
  switch(xde) {
  case 9: m_dword(xix+32)= xbc;
  case 8: m_dword(xix+28)= xbc;
  case 7: m_dword(xix+24)= xbc;
  case 6: m_dword(xix+20)= xbc;
  case 5: m_dword(xix+16)= xbc;
  case 4: m_dword(xix+12)= xbc;
  case 3: m_dword(xix+8)= xbc;
  case 2: m_dword(xix+4)= xbc;
  };
frfdyloop:
  m_dword(xix)&= xiy;
  m_dword(xix+(char)qh)&= xiz;
  xix+= xhl;
  _wa-= 1;
  if((word)wa!=0) goto frfdxloop;
  qwa-= 1;
  if(qwa!=0) goto frblkloop;
  goto frblknext;
frfword:
// hl<320AŌ̓[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16;
#else
  xiy&= 0x0ffff;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= frfwyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  xhl= widthdst;
  c+= c;
  qh= c;
  _wa= yheight;
  xbc= 0;
frfwxloop:
  switch(xde) {
  case 9: m_dword(xix+32)= xbc;
  case 8: m_dword(xix+28)= xbc;
  case 7: m_dword(xix+24)= xbc;
  case 6: m_dword(xix+20)= xbc;
  case 5: m_dword(xix+16)= xbc;
  case 4: m_dword(xix+12)= xbc;
  case 3: m_dword(xix+8)= xbc;
  case 2: m_dword(xix+4)= xbc;
  };
frfwyloop:
  m_dword(xix)&= xiy;
  m_word(xix+(char)qh)&= iz;
  xix+= xhl;
  _wa-= 1;
  if((word)wa!=0) goto frfwxloop;
  qwa-= 1;
  if(qwa!=0) goto frblkloop;
  goto frblknext;
frmulti:
//hl>320
  xde= gcBit_not8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto frmword;
frmdword:
//Ōオdword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16;
#else
  xiy&= 0x0ffff;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz&= 0x0ffff;
#else
  xiz= xiz<<16;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  _wa= hl;
  _wa-= 1;
  _hl+= hl;
  _hl+= hl;
  _de= widthdst; //lower word
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qhl= bc;
  xbc= 0;
frmdyloop:
  (mem= xix,xix+= 4,m_dword(mem))&= xiy;
  _hl= wa;
frmdxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xbc;
  _hl--; if((word)hl!=0) goto frmdxloop;
  m_dword(xix)&= xiz;
  xix+= xde;
  qhl--; if(qhl!=0) goto frmdyloop;
  qwa-= 1;
  if(qwa!=0) goto frblkloop;
  goto frblknext;
frmword:
//Ōオword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16;
#else
  xiy&= 0x0ffff;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  _wa= hl;
  _wa-= 1;
  _hl+= hl;
  _hl+= hl;
  _de= widthdst; //lower word
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qhl= bc;
  xbc= 0;
frmwyloop:
  (mem= xix,xix+= 4,m_dword(mem))&= xiy;
  _hl= wa;
frmwxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xbc;
  _hl--; if(hl!=0) goto frmwxloop;
  m_word(xix)&= iz;
  xix+= xde;
  qhl--; if(qhl!=0) goto frmwyloop;
  qwa-= 1;
  if(qwa!=0) goto frblkloop;
  goto frblknext;
frerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
