// gc::bit::copymask
//   coded by zoro (悵)
// 1997-11-17 begin
// 1999-02-02 debugged, changed for ai15, checked
// 2007-07-01 to .cc using mactocc
//      07-04 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitCopyMask( gcBit* dst, gcBit* src, dword mask, gcRgn* rgn
, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
#define xsp ((dword)&pattern[0]-16)
  word qwa;
  word qhl;
  word qde;
  word qiz;
  byte w, c, d;
  byte qixh;

  word widthsrc;
  word widthdst;
  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;
  dword tailmask;
  byte pattern[16];

  xwa= (dword)dst;
//<assert object>
  xbc= (dword)src;
//<assert object>
  xde= (dword)rgn;
//<assert object>
  if(m_word(xde+8)!=0) goto mccopyerr;
  xhl= (dword)mask;
  widthsrc= m_word(xbc+2);
  xbc+= 4;
  if(m_word(xbc-4)==0) goto mcincsrc;
  xbc= m_dword(xbc);
mcincsrc:
  xiz= xwa;
  widthdst= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto mcincdst;
  xiz= m_dword(xiz);
mcincdst:
  _wa= xhl>>24;
  _wa= wa&0xff|wa<<8&0xff00;
  m_word(xsp+30)= wa;
  m_word(xsp+28)= wa;
  _wa= xhl>>16;
  _wa= wa&0xff|wa<<8&0xff00;
  m_word(xsp+26)= wa;
  m_word(xsp+24)= wa;
  _wa= xhl>>8;
  _wa= wa&0xff|wa<<8&0xff00;
  m_word(xsp+22)= wa;
  m_word(xsp+20)= wa;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+18)= hl;
  m_word(xsp+16)= hl;
  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= 0;
  _wa-= iy;
  toppos= hl;
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  w= 0x3;
  w&= (byte)bc;
  w+= w;
  w+= w;
  w^= 0x1c;
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  qixh= w;
  _wa&= 7;
  if((word)wa==0) goto mc8start;
mcstart:
  xiy-= 1;
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto mcblkloopin;
mc8start:
  topsrc= xiy;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto mc8blkloopin;
mcxtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= tailmask;
  _bc&= iz;
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto mcyloopex;
mcyloop:
  xiy+= nextsrc;
  xix+= nextdst;
  _de= de&0xfff0|(de-4)&0x0f;
mcyloopin:
  xiz= m_dword(xsp+(char)de);
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifdef __BIG_ENDIAN__
  d= (byte)xbc;
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  d= (byte)xbc;
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= qwa; //headmask
  _bc&= iz;
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _hl= qde; //xcount
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= d;
  d^= c;
  c&= w;
  c^= d;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl<=0) goto mcxloopex;
mcxloop:
  xbc^= m_dword(xix);
  xbc&= xiz;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= d;
  d^= c;
  c&= w;
  c^= d;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl>0) goto mcxloop;
mcxloopex:
  if((short)hl<0) goto mcxtailword;
  xbc^= m_dword(xix);
  xbc&= tailmask;
  xbc&= xiz;
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto mcyloop;
mcyloopex:
  blkcount-= 1;
  if(blkcount==0) goto mcblknext;
mcblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
mcblkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_bittable;
  if((word)hl<17) goto mconeword;
  if((word)hl>=25) goto mcmulti;
  if(c>=8) goto mconeword1;
mcmulti:
  c+= c;
  _bc= m_word(xde+(char)c);
  qwa= bc;
  _hl-= 1;
#ifdef __BIG_ENDIAN__
  xiz= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xiz= m_dword(xde+(char)c);
#endif
  tailmask= xiz;
  _hl= (word)hl>>(4+15)%16+1;
  qde= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  _bc+= 2;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  _de= qixh; //ypattern
  goto mcyloopin;
mconeword1:
  xde= xde-16; //somehow tricky
  xix+= 1;
  xiy+= 1;
mconeword:
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl+= hl;
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  c= qixh;
  qiz= c;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
mconeyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= iz; //masksrc
  _bc&= m_word(xsp+(char)qiz);
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  qiz= qiz&0xfff0|(qiz-4)&0x0f;
  qwa--; if(qwa!=0) goto mconeyloop;
  blkcount-= 1;
  if(blkcount!=0) goto mcblkloop;
mcblknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto mcepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto mcblkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
mcblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  c= (byte)bc;
  c+= c;
  c+= c;
  c= -c;
  c+= qixh;
  c&= 0x0c;
  c|= 0x10;
  qixh= c;
  blkcount= hl;
  _hl= toppos;
  goto mcblkloopin;
// bit xor aligned
mc8multi:
  xde= gcBit_bittable;
  _hl-= 17;
#ifdef __BIG_ENDIAN__
  xiz= m_word(xde+c*2)<<16|0xffff;
  xde= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c+= c;
  _iz= m_word(xde+(char)c);
  xiz|= 0xffff0000;
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xde= m_dword(xde+(char)c);
#endif
  tailmask= xde;
  _hl= (word)hl>>(4+15)%16+1;
  qwa= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  _wa= qixh;
  goto mc8yloopin;
mc8xtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= tailmask;
  _bc&= de;
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto mc8yloopex;
mc8yloop:
  xiy+= nextsrc;
  xix+= nextdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
mc8yloopin:
  xde= m_dword(xsp+(char)wa);
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
  xbc^= m_dword(xix);
  xbc&= xiz;
  xbc&= xde;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl= qwa;
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl<=0) goto mc8xloopex;
mc8xloop:
  xbc^= m_dword(xix);
  xbc&= xde;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl>0) goto mc8xloop;
mc8xloopex:
  if((short)hl<0) goto mc8xtailword;
  xbc^= m_dword(xix);
  xbc&= tailmask;
  xbc&= xde;
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto mc8yloop;
mc8yloopex:
  blkcount-= 1;
  if(blkcount==0) goto mc8blknext;
mc8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe
mc8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=41) goto mc8multi;
  if((word)hl<33) goto mc8blkword;
  if(c<8) goto mc8multi;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
mc8twoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  c= qixh;
  qwa= c;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
mc8twoyloop:
  xbc= m_dword(xiy);
  xbc^= m_dword(xix);
  xbc&= xiz; //mask
  xbc&= m_dword(xsp+(char)qwa);
  m_dword(xix)^= xbc;
  xiy+= xhl;
  xix+= xde;
  qwa= qwa&0xfff0|(qwa-4)&0x0f;
  _wa--; if(wa!=0) goto mc8twoyloop;
  blkcount-= 1;
  if(blkcount!=0) goto mc8blkloop;
  goto mc8blknext;
mc8blkword:
  if((word)hl<17) goto mc8oneword;
  if((word)hl>=25) goto mc8twoword;
  if(c<8) goto mc8twoword;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
mc8oneword:
  xde= gcBit_bittable;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  c= qixh;
  qwa= c;
mc8oneyloop:
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= iz; //mask
  _bc&= m_word(xsp+(char)qwa);
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  qwa= qwa&0xfff0|(qwa-4)&0x0f;
  _wa--; if(wa!=0) goto mc8oneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto mc8blkloop;
mc8blknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto mcepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto mc8blkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
mc8blkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  c= (byte)bc;
  c+= c;
  c+= c;
  c= -c;
  c+= qixh;
  c&= 0x0c;
  c|= 0x10;
  qixh= c;
  blkcount= hl;
  _hl= toppos;
  goto mc8blkloopin;
mcepilogue:
  _hl= 1;
  return(short)hl;
mccopyerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
