// gc::bit::fill
//   coded by zoro (悵)
// 1997-11-15 write off, checked
// 2007-06-27 from fill.cc
//      07-04 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitInvert( gcBit* dst, gcRgn* rgn, short p_dstx, short p_dsty)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  byte c;
  byte qh;

  word xposition;
  word yheight;
  word toppos;
  dword widthdst;
  dword topdst;
  dword blkrgn;
  dword blkdst;

  xwa= (dword)dst;
//<assert object dst>
  xde= (dword)rgn;
//<assert object rgn>
  if(m_word(xde+8)!=0) goto fierr;
  xiz= xwa;
  _hl= m_word(xiz+2);
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  widthdst= xhl; //widthdst
  xiz+= 4;
  if(m_word(xiz-4)==0) goto fiincdst;
  xiz= m_dword(xiz);
fiincdst:
  _ix= p_dstx;
  _ix+= m_word(xde); //rgn.x
  _hl= 0x000f;
  _hl&= ix;
  toppos= hl;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz;
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  qwa= bc;
  xde= xde+16;
  goto fiblkloopin;
fiblkword:
  if((word)hl<17) goto fioneword;
  if((word)hl>=25) goto fitwoword;
  if(c<8) goto fitwoword;
  c-= 8;
  _hl-= 8;
  xix+= 1;
fioneword:
  xde= gcBit_bit8table;
  _hl+= hl;
  _iz= m_word(xde+(short)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  xde= widthdst;
  _wa= yheight;
fioneyloop:
  m_word(xix)^= iz;
  xix+= xde;
  _wa--; if((word)wa!=0) goto fioneyloop;
  qwa-= 1;
  if(qwa==0) goto fiblknext;
fiblkloop:
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
fiblkloopin:
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc>>= (3+15)%16+1;
  xix+= xbc;
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=321) goto fimulti;
  if((word)hl>=41) goto fifast;
  if((word)hl<33) goto fiblkword;
  if(c<8) goto fifast;
  c-= 8;
  _hl-= 8;
  xix+= 1;
fitwoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  xde= widthdst;
  _wa= yheight;
fitwoyloop:
  m_dword(xix)^= xiz;
  xix+= xde;
  _wa--; if((word)wa!=0) goto fitwoyloop;
  qwa-= 1;
  if(qwa!=0) goto fiblkloop;
fiblknext:
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto fiepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto fiblkexist;
  yheight+= bc;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
fiblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  qwa= hl;
  _hl= toppos;
  goto fiblkloopin;
fiepilogue:
  _hl= 1;
  return(short)hl;
fifast:
//hl<=320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto fifword;
fifdword:
// hl<320AŌ̓_u[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= fifdyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  xhl= widthdst;
  c+= c;
  qh= c;
  _wa= yheight;
  xbc= 0xffffffff;
fifdxloop:
  switch(xde) {
  case 9: m_dword(xix+32)^= xbc;
  case 8: m_dword(xix+28)^= xbc;
  case 7: m_dword(xix+24)^= xbc;
  case 6: m_dword(xix+20)^= xbc;
  case 5: m_dword(xix+16)^= xbc;
  case 4: m_dword(xix+12)^= xbc;
  case 3: m_dword(xix+8)^= xbc;
  case 2: m_dword(xix+4)^= xbc;
  };
fifdyloop:
  m_dword(xix)^= xiy;
  m_dword(xix+(char)qh)^= xiz;
  xix+= xhl;
  _wa-= 1;
  if((word)wa!=0) goto fifdxloop;
  qwa-= 1;
  if(qwa!=0) goto fiblkloop;
  goto fiblknext;
fifword:
// hl<320AŌ̓[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= fifwyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  xhl= widthdst;
  c+= c;
  qh= c;
  _wa= yheight;
  xbc= 0xffffffff;
fifwxloop:
  switch(xde) {
  case 9: m_dword(xix+32)^= xbc;
  case 8: m_dword(xix+28)^= xbc;
  case 7: m_dword(xix+24)^= xbc;
  case 6: m_dword(xix+20)^= xbc;
  case 5: m_dword(xix+16)^= xbc;
  case 4: m_dword(xix+12)^= xbc;
  case 3: m_dword(xix+8)^= xbc;
  case 2: m_dword(xix+4)^= xbc;
  };
fifwyloop:
  m_dword(xix)^= xiy;
  m_word(xix+(char)qh)^= iz;
  xix+= xhl;
  _wa-= 1;
  if((word)wa!=0) goto fifwxloop;
  qwa-= 1;
  if(qwa!=0) goto fiblkloop;
  goto fiblknext;
fimulti:
//hl>320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto fimword;
fimdword:
//Ōオdword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  _wa= hl;
  _wa-= 1;
  _hl+= hl;
  _hl+= hl;
  _de= widthdst; //lower word
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qhl= bc;
  xbc= 0xffffffff;
fimdyloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xiy;
  _hl= wa;
fimdxloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl--; if((word)hl!=0) goto fimdxloop;
  m_dword(xix)^= xiz;
  xix+= xde;
  qhl--; if(qhl!=0) goto fimdyloop;
  qwa-= 1;
  if(qwa!=0) goto fiblkloop;
  goto fiblknext;
fimword:
//Ōオword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  _wa= hl;
  _wa-= 1;
  _hl+= hl;
  _hl+= hl;
  _de= widthdst; //lower word
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qhl= bc;
  xbc= 0xffffffff;
fimwyloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xiy;
  _hl= wa;
fimwxloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl--; if(hl!=0) goto fimwxloop;
  m_word(xix)^= iz;
  xix+= xde;
  qhl--; if(qhl!=0) goto fimwyloop;
  qwa-= 1;
  if(qwa!=0) goto fiblkloop;
  goto fiblknext;
fierr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
