// gc::bit::move
//   coded by zoro (悵)
// 1997-11-14 begin
//      11-14 write off, checked
// 2007-06-15 to .cc using mactocc
//      06-25 checked on litle-endian

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

//#define TSCOPY

short gcBitMove( gcBit* dst, gcBit* src, gcRgn* rgn
, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word widthsrc;
  word widthdst;

  xwa= (dword)dst;
//<assert object>
  xbc= (dword)src;
//<assert object>
  xde= (dword)rgn;
//<assert object>
  if(m_word(xde+8)!=0) goto bmcopyerr;
  widthsrc= m_word(xbc+2);
  xbc+= 4;
  if(m_word(xbc-4)==0) goto bmincsrc;
  xbc= m_dword(xbc);
bmincsrc:
  xiz= xwa;
  widthdst= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto bmincdst;
  xiz= m_dword(xiz);
bmincdst:
  if(xbc!=xiz) goto bmcopyin;
//keep xbc, xiz, xde
  _hl= p_srcx;
  _hl-= p_dstx;
  if((short)hl<0) goto bmright;
#ifndef TSCOPY
  if(hl>=m_word(xde+4)) goto bmcopyin;
#endif
  _hl= p_srcy;
  _hl-= p_dsty;
  if((short)hl>=0) goto bmcopyin;
  _hl+= m_word(xde+6); //rgn.h
#ifndef TSCOPY
  if((short)hl<=0) goto bmcopyin;
#endif
  return gcBit_bottomin(xiz, widthdst, xbc, widthsrc, xde
  , p_dstx, p_dsty, p_srcx, p_srcy);
bmright:
  _hl+= m_word(xde+4); //rgn.w
#ifndef TSCOPY
  if((short)hl<=0) goto bmcopyin;
#endif
  _hl= p_srcy;
  _hl-= p_dsty;
  if((short)hl<=0) goto bmtail;
#ifndef TSCOPY
  if(hl>=m_word(xde+6)) goto bmcopyin;
#endif
  return gcBit_rightin(xiz, widthdst, xbc, widthsrc, xde
  , p_dstx, p_dsty, p_srcx, p_srcy);
bmtail:
  _hl+= m_word(xde+6);
#ifndef TSCOPY
  if((short)hl<=0) goto bmcopyin;
#endif
  return gcBit_tailin(xiz, widthdst, xbc, widthsrc, xde
  , p_dstx, p_dsty, p_srcx, p_srcy);
bmcopyin:
  return gcBit_copyin(xiz, widthdst, xbc, widthsrc, xde
  , p_dstx, p_dsty, p_srcx, p_srcy);
bmcopyerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};

