// gc::bit::orpat
//   coded by zoro (悵)
// 1997-11-16 begin
//      11-16 write off, checked
// 2007-06-27 from xorpat.cc
//      07-04 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitOrPat(gcBit* dst, dword pat, gcRgn* rgn, short p_dstx, short p_dsty)
{
#include "../tlcs900.h"
#define xsp ((dword)&pattern[0]-16)
  byte c;
  byte w;
  byte qixh;
  word qwa;
  word qhl;
  
  word xposition;
  word yheight;
  word toppos;
  word blkcount;
  dword widthdst;
  dword topdst;
  dword blkrgn;
  dword blkdst;
  dword nextdst;
  byte pattern[16];


  xwa= (dword)dst;
//<assert object dst>
  xde= (dword)rgn;
//<assert object rgn>
  if(m_word(xde+8)!=0) goto poerr;
  xbc= (dword)pat;
  xiz= xwa;
  _iy= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto poincdst;
  xiz= m_dword(xiz);
poincdst:
  _hl= xbc>>24;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+30)= hl;
  m_word(xsp+28)= hl;
  _hl= xbc>>16;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+26)= hl;
  m_word(xsp+24)= hl;
  _hl= xbc>>8;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+22)= hl;
  m_word(xsp+20)= hl;
  _bc= bc&0xff|bc<<8&0xff00;
  m_word(xsp+18)= bc;
  m_word(xsp+16)= bc;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  widthdst= xiy;
  _ix= p_dstx;
  _ix+= m_word(xde); //rgn.x
  _hl= 0x000f;
  _hl&= ix;
  toppos= hl;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz;
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  w= 0x3;
  w&= (byte)bc;
  w+= w;
  w+= w;
  w^= 0x1c;
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto poblkloopin;
poblkword:
  if((word)hl<17) goto pooneword;
  if((word)hl>=25) goto potwoword;
  if(c<8) goto potwoword;
  c-= 8;
  _hl-= 8;
  xix+= 1;
pooneword:
  xde= gcBit_bit8table;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  xde= widthdst;
  _hl= yheight;
pooneyloop:
  _bc= m_word(xsp+(char)wa);
  _bc&= iz;
  m_word(xix)|= bc;
  xix+= xde;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  _hl--; if((word)hl!=0) goto pooneyloop;
  blkcount-= 1;
  if(blkcount==0) goto poblknext;
poblkloop:
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
poblkloopin:
  _wa= w;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xix+= xbc;
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=321) goto pomulti;
  if((word)hl>=41) goto pofast;
  if((word)hl<33) goto poblkword;
  if(c<8) goto pofast;
  c-= 8;
  _hl-= 8;
  xix+= 1;
potwoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  xde= widthdst;
  _hl= yheight;
potwoyloop:
  xbc= m_dword(xsp+(char)wa);
  xbc&= xiz;
  m_dword(xix)|= xbc;
  xix+= xde;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  _hl--; if((word)hl!=0) goto potwoyloop;
  blkcount-= 1;
  if(blkcount!=0) goto poblkloop;
poblknext:
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto poepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto poblkexist;
  yheight+= bc;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
poblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  c= (byte)bc;
  c+= c;
  c+= c;
  w-= c;
  w&= 0x0c;
  w|= 0x10;
  blkcount= hl;
  _hl= toppos;
  goto poblkloopin;
poepilogue:
  _hl= 1;
  return(short)hl;
pofast:
//hl<=320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto pofword;
pofdword:
// hl<320AŌ̓_u[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= pofdyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  c+= c;
  qixh= c;
  _bc= yheight;
  qwa= bc;
  xbc= m_dword(xsp+(char)wa);
pofdxloop:
  switch(xde) {
  case 9: m_dword(xix+32)|= xbc;
  case 8: m_dword(xix+28)|= xbc;
  case 7: m_dword(xix+24)|= xbc;
  case 6: m_dword(xix+20)|= xbc;
  case 5: m_dword(xix+16)|= xbc;
  case 4: m_dword(xix+12)|= xbc;
  case 3: m_dword(xix+8)|= xbc;
  case 2: m_dword(xix+4)|= xbc;
  };
pofdyloop:
  xhl= xbc;
  xbc&= xiy;
  m_dword(xix)|= xbc;
  xhl&= xiz;
  m_dword(xix+(char)qixh)|= xhl;
  xix+= widthdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  xbc= m_dword(xsp+(char)wa);
  qwa-= 1;
  if(qwa!=0) goto pofdxloop;
  blkcount-= 1;
  if(blkcount!=0) goto poblkloop;
  goto poblknext;
pofword:
// hl<320AŌ̓[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= pofwyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  c+= c;
  qixh= c;
  _bc= yheight;
  qwa= bc;
  xbc= m_dword(xsp+(char)wa);
pofwxloop:
  switch(xde) {
  case 9: m_dword(xix+32)|= xbc;
  case 8: m_dword(xix+28)|= xbc;
  case 7: m_dword(xix+24)|= xbc;
  case 6: m_dword(xix+20)|= xbc;
  case 5: m_dword(xix+16)|= xbc;
  case 4: m_dword(xix+12)|= xbc;
  case 3: m_dword(xix+8)|= xbc;
  case 2: m_dword(xix+4)|= xbc;
  };
pofwyloop:
  _hl= bc;
  xbc&= xiy;
  m_dword(xix)|= xbc;
  _hl&= iz;
  m_word(xix+(char)qixh)|= hl;
  xix+= widthdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  xbc= m_dword(xsp+(char)wa);
  qwa-= 1;
  if(qwa!=0) goto pofwxloop;
  blkcount-= 1;
  if(blkcount!=0) goto poblkloop;
  goto poblknext;
pomulti:
//hl>320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto pomword;
pomdword:
//Ōオdword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  qwa= hl;
  qwa-= 1;
  _hl+= hl;
  _hl+= hl;
  _bc= widthdst; //lower word
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc;
pomdyloop:
  xde= m_dword(xsp+(char)wa);
  xbc= xde;
  xbc&= xiy;
  (mem= xix,xix+= 4,m_dword(mem))|= xbc;
  _hl= qwa;
pomdxloop:
  (mem= xix,xix+= 4,m_dword(mem))|= xde;
  _hl--; if(hl!=0) goto pomdxloop;
  xde&= xiz;
  m_dword(xix)|= xde;
  xix+= nextdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  qhl--; if(qhl!=0) goto pomdyloop;
  blkcount-= 1;
  if(blkcount!=0) goto poblkloop;
  goto poblknext;
pomword:
//Ōオword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  qwa= hl;
  qwa-= 1;
  _hl+= hl;
  _hl+= hl;
  _bc= widthdst; //lower word
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc;
pomwyloop:
  xde= m_dword(xsp+(char)wa);
  xbc= xde;
  xbc&= xiy;
  (mem= xix,xix+= 4,m_dword(mem))|= xbc;
  _hl= qwa;
pomwxloop:
  (mem= xix,xix+= 4,m_dword(mem))|= xde;
  _hl--; if(hl!=0) goto pomwxloop;
  _de&= iz;
  m_word(xix)|= de;
  xix+= nextdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  qhl--; if(qhl!=0) goto pomwyloop;
  blkcount-= 1;
  if(blkcount!=0) goto poblkloop;
  goto poblknext;
poerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
