// gc::bit::copy::right
//   coded by zoro (悵)
// 1997-11-13 write off, checked
// 1999-02-01 changed for ai15, checked
// 2007-06-20 to .cc using mactocc
//      06-25 checked on litle-endian
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBit_rightin(dword addrdst, word widthdst, dword addrsrc, word widthsrc
, dword addrrgn, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword toprgn;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;

dmesg("rightin\n");
  xiz= addrdst;
  xbc= addrsrc;
  xde= addrrgn;
  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= iy;
  toppos= hl;
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  _wa&= 7;
  if((word)wa==0) goto br8start;
brstart:
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  xde= xde+16;
  goto brblkin;
br8start:
  xiy-= 2;
  xix-= 2;
  topsrc= xiy;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  xde= xde+16;
  goto br8blkin;
// bit copy right shifted
brxtailword:
#ifndef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= (xix-= 2,mem= xix,m_word(mem));
  _bc&= iz; //tailmask͂Ă
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto bryloopex;
bryloop:
  xiy+= nextsrc;
  xix+= nextdst;
bryloopin:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#else
  e= (byte)xbc; //Jz
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _bc^= m_word(xix);
  _bc&= qwa; //headmask
  m_word(xix)^= bc;
  _hl= qde; //xcount
  xbc= (xiy-= 4,mem= xiy,m_dword(mem));
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifndef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl+= 2;
  if((short)hl>=0) goto brxloopex;
brxloop:
  (xix-= 4,mem= xix,m_dword(mem))= xbc;
  xbc= (xiy-= 4,mem= xiy,m_dword(mem));
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifndef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl+= 2;
  if((short)hl<0) goto brxloop;
brxloopex:
  if((word)hl!=0) goto brxtailword;
  xbc^= (xix-= 4,mem= xix,m_dword(mem));
  xbc&= xiz; //tailmask
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto bryloop;
bryloopex:
  blkcount-= 1;
  if(blkcount==0) goto brblknext;
brblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //spacewidth
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
brblkloopin:
dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _bc= 0xfff0;
  _bc&= hl;
  _bc= (short)bc>>(3+15)%16+1;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //markwidth
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_nottable+2; //.xde= 398;
  if((short)hl>=-1) goto broneword;
  if((short)hl<-9) goto brmulti;
  if(c<8) goto broneword1;
brmulti:
  c+= c; //0:0080 1:00c0 2:00e0 15:ffff
  _bc= m_word(xde+c); //.bc= m_word(xde+(char)c);
  qwa= bc;
  _hl+= 1;
#ifdef __BIG_ENDIAN__
  xiz= m_dword(gcBit_bit8tabletwo+(hl&0x001f)*4);
#else
  c= 0x0f;
  c&= (byte)hl;
  c+= c; //-16:0xffff -15:0xff7f -14:0xff3f .. -1:0x0100
  c+= 32;
  _iz= m_word(xde+(char)c);
  xiz|= 0xffff0000;
#endif
  _hl= (short)hl>>(4+15)%16+1;
  qde= hl; //xcount(minus)
  _hl+= hl;
  _bc= widthdst;
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _hl&= 0xfffc;
  _bc= widthsrc;
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextsrc= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto bryloopin;
broneword1:
  xde= xde+16; //somehow tricky
  xix-= 1;
  xiy-= 1;
broneword:
  c+= c; //0:0080 1:00c0 2:00e0 15:ffff
  _iz= m_word(xde+(char)c);
  _hl+= hl; //-1:0000 0:0080 ... 14:feff
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
broneyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#else
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _bc^= m_word(xix);
  _bc&= iz; //masksrc
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  qwa--; if(qwa!=0) goto broneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto brblkloop;
brblknext:
//̃XCX
  xde= toprgn;
  _hl= 0;
  _hl-= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl==0) goto brepilogue;
//̍s
  _bc= 0xffff;
  _bc+= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc!=0) goto brblkexist;
  yheight+= hl; //XCXcOsɒǉ
  _hl= 0;
  _hl-= (mem= xde,xde+= 2,m_word(mem));
  _bc= 0xffff;
  _bc+= (mem= xde,xde+= 2,m_word(mem));
brblkexist:
  mem= yheight; yheight= hl; _hl= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)hl;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)hl;
  xix+= topdst;
  topdst= xix;
  _hl= toppos;
brblkin:
  xhl&= 0x0ffff;
  blkcount= bc;
brblkseek:
  xhl+= (mem= xde,xde+= 4,m_dword(mem));
  _bc--; if((word)bc!=0) goto brblkseek;
  toprgn= xde;
  _hl= (word)hl+(xhl>>16);
  _hl-= 1;
  goto brblkloopin;
// bit copy forward aligned
br8multi:
  xde= gcBit_nottable+2;
  c+= c;
  _wa= m_word(xde+(char)c);
  _hl+= 1;
  c= 0x0f;
  c&= (byte)hl;
  c+= c;
  c+= 32;
  _bc= m_word(xde+(char)c);
  qbc= bc;
  _hl= (short)hl>>(3+15)%16+1;
  _hl= ~hl;
  _hl&= 0xfffe;
  _iz= widthsrc;
  _iz+= hl;
  if(xiz&0x08000) xiz|= 0xffff0000; else xiz&= 0x0ffff;
  _de= widthdst;
  _de+= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _hl= (short)hl>>(1+15)%16+1;
  _bc= yheight;
  qhl= bc;
  dmesg("%d+%d < %d+%d %04x(%d)%04x x%d\n", xix, xde, xiy, xiz, wa, hl, qbc, qhl);
br8yloop:
  _bc= m_word(xiy+2);
  _bc^= m_word(xix+2);
  _bc&= wa; //headmask
  m_word(xix+2)^= bc;
  _bc= hl; //xcount
  do { m_word(xix)= m_word(xiy);
  xix-= 2; xiy-= 2; } while(--_bc, (word)bc);
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= qbc; //tailmask
  m_word(xix)^= bc;
  xiy+= xiz;
  xix+= xde;
  qhl--; if(qhl!=0) goto br8yloop;
  qwa-= 1;
  if(qwa==0) goto br8blknext;
br8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //spacewidth
// xix=dest xiy=src xde=rgn hl=prev-xe
br8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _bc= 0xfff0;
  _bc&= hl;
  _bc= (short)bc>>(3+15)%16+1;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //markwidth
  blkrgn= xde; //save
  xposition= hl; //save
  if((short)hl<-25) goto br8multi;
  if((char)hl>=-17) goto br8blkword;
  if(c>=8) goto br8multi;
  c+= 8;
  _hl+= 8;
  xiy-= 1;
  xix-= 1;
br8twoword:
  xde= gcBit_bit8tabletwo+17*4;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(char)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
br8twoyloop:
  xbc= m_dword(xiy);
  xbc^= m_dword(xix);
  xbc&= xiz; //mask
  m_dword(xix)^= xbc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto br8twoyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto br8blkloop;
  goto br8blknext;
br8blkword:
  if((char)hl>=-1) goto br8oneword;
  if((char)hl<-9) goto br8twoword;
  if(c>=8) goto br8twoword;
  c+= 8;
  _hl+= 8;
  xiy-= 1;
  xix-= 1;
br8oneword:
  xde= gcBit_bittable+2;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  xiy+= 2;
  xix+= 2;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
br8oneyloop:
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= iz; //mask
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto br8oneyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto br8blkloop;
br8blknext:
//̃XCX
  xde= toprgn;
  _hl= 0;
  _hl-= (mem= xde,xde+= 2,m_word(mem));
  if(hl==0) goto brepilogue;
//̍s
  _bc= 0xffff;
  _bc+= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc!=0) goto br8blkexist;
  yheight+= hl; //XCXcOsɒǉ
  _hl= 0;
  _hl-= (mem= xde,xde+= 2,m_word(mem));
  _bc= 0xffff;
  _bc+= (mem= xde,xde+= 2,m_word(mem));
br8blkexist:
  mem= yheight; yheight= hl; _hl= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)hl;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)hl;
  xix+= topdst;
  topdst= xix;
  _hl= toppos;
br8blkin:
  xhl&= 0x0ffff;
  qwa= bc;
br8blkseek:
  xhl+= (mem= xde,xde+= 4,m_dword(mem));
  _bc--; if((word)bc!=0) goto br8blkseek;
  toprgn= xde;
  _hl= (word)hl+(xhl>>16);
  _hl-= 1;
  goto br8blkloopin;
brepilogue:
  _hl= 1;
  return(short)hl;
};
