// gc::bit::copy::andnot
//   coded by zoro (悵)
// 1997-11-14 write off, checked
// 1999-02-02 changed for ai15, checked
// 2007-06-26 to .cc using mactocc
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitAndNot( gcBit* dst, gcBit* src, gcRgn* rgn
, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word widthsrc;
  word widthdst;
  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;

  xwa= (dword)dst;
//<assert object>
  xbc= (dword)src;
//<assert object>
  xde= (dword)rgn;
//<assert object>
  if(m_word(xde+8)!=0) goto nacopyerr;
  widthsrc= m_word(xbc+2);
  xbc+= 4;
  if(m_word(xbc-4)==0) goto naincsrc;
  xbc= m_dword(xbc);
naincsrc:
  xiz= xwa;
  widthdst= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto naincdst;
  xiz= m_dword(xiz);
naincdst:

  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= 0;
  _wa-= iy;
  toppos= hl;
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  _wa&= 7;
  if((word)wa==0) goto na8start;
nastart:
  xiy-= 1;
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto nablkloopin;
na8start:
  topsrc= xiy;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  qwa= bc;
  xde= xde+16;
  goto na8blkloopin;
// not and shifted
naxtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc|= iz; //tailmask
  m_word(xix)&= bc;
  qhl-= 1;
  if(qhl==0) goto nayloopex;
nayloop:
  xiy+= nextsrc;
  xix+= nextdst;
nayloopin:
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifdef __BIG_ENDIAN__
  e= (byte)xbc;
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#endif
  _bc|= qwa; //headmask
  (mem= xix,xix+= 2,m_word(mem))&= bc;
  _hl= qde; //xcount
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;  
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl<=0) goto naxloopex;
naxloop:
  (mem= xix,xix+= 4,m_dword(mem))&= xbc;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;  
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl>0) goto naxloop;
naxloopex:
  if((short)hl<0) goto naxtailword;
  xbc|= xiz; //tailmask
  m_dword(xix)&= xbc;
  qhl--; if(qhl!=0) goto nayloop;
nayloopex:
  blkcount-= 1;
  if(blkcount==0) goto nablknext;
nablkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
nablkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_nottable;
  if((word)hl<17) goto naoneword;
  if((word)hl>=25) goto namulti;
  if(c>=8) goto naoneword1;
namulti:
  c+= c;
  _bc= m_word(xde+(char)c);
  qwa= bc;
  _hl-= 1;
#ifdef __BIG_ENDIAN__
  xiz= m_word(gcBit_bittable+2+(hl&0x000f)*2);
#else
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xiz= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  qde= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  _bc+= 2;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto nayloopin;
naoneword1:
  xde= xde-16; //somehow tricky
  xix+= 1;
  xiy+= 1;
naoneword:
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl+= hl;
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
naoneyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#endif
  _bc&= iz; //masksrc
  _bc= ~bc;
  m_word(xix)&= bc;
  xiy+= xhl;
  xix+= xde;
  qwa--; if(qwa!=0) goto naoneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto nablkloop;
nablknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto naepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto nablkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
nablkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  blkcount= hl;
  _hl= toppos;
  goto nablkloopin;
// bit xor aligned
na8multi:
  xde= gcBit_nottable;
  _hl-= 17;
#ifdef __BIG_ENDIAN__
  xiz= m_word(xde+c*2)<<16;
  xde= m_word(gcBit_bittable+2+(hl&0x000f)*2);
#else
  c+= c;
  _iz= m_word(xde+(char)c);
  xiz&= 0x0ffff;
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xde= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  _wa= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  goto na8yloopin;
na8xtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc|= de;
  m_word(xix)&= bc;
  qhl-= 1;
  if(qhl==0) goto na8yloopex;
na8yloop:
  xiy+= nextsrc;
  xix+= nextdst;
na8yloopin:
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  xbc|= xiz;
  (mem= xix,xix+= 4,m_dword(mem))&= xbc;
  _hl= wa;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl<=0) goto na8xloopex;
na8xloop:
  (mem= xix,xix+= 4,m_dword(mem))&= xbc;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl>0) goto na8xloop;
na8xloopex:
  if((short)hl<0) goto na8xtailword;
  xbc|= xde;
  m_dword(xix)&= xbc;
  qhl--; if(qhl!=0) goto na8yloop;
na8yloopex:
  qwa-= 1;
  if(qwa==0) goto na8blknext;
na8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe
na8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=41) goto na8multi;
  if((word)hl<33) goto na8blkword;
  if(c<8) goto na8multi;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
na8twoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  xiz= ~xiz;
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
na8twoyloop:
  xbc= 0xffffffff;
  xbc^= m_dword(xiy);
  xbc|= xiz; //mask
  m_dword(xix)&= xbc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto na8twoyloop;
  qwa-= 1;
  if(qwa!=0) goto na8blkloop;
  goto na8blknext;
na8blkword:
  if((word)hl<17) goto na8oneword;
  if((word)hl>=25) goto na8twoword;
  if(c<8) goto na8twoword;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
na8oneword:
  xde= gcBit_bittable;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
na8oneyloop:
  _bc= m_word(xiy);
  _bc&= iz; //mask
  _bc= ~bc;
  m_word(xix)&= bc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto na8oneyloop;
  qwa-= 1;
  if(qwa!=0) goto na8blkloop;
na8blknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto naepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto na8blkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
na8blkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  qwa= hl;
  _hl= toppos;
  goto na8blkloopin;
naepilogue:
  _hl= 1;
  return(short)hl;
nacopyerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
