// gc::bit::fillpat
//   coded by zoro (悵)
// 1997-11-16 begin
//      11-16 write off, checked
// 2007-06-27 to .cc using mactocc
//      07-04 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitFillPat(gcBit* dst, dword pat, gcRgn* rgn, short p_dstx, short p_dsty)
{
#include "../tlcs900.h"
#define xsp ((dword)&pattern[0]-16)
  byte c;
  byte w;
  byte qixh;
  word qwa;
  word qhl;
  
  word xposition;
  word yheight;
  word toppos;
  word blkcount;
  dword widthdst;
  dword topdst;
  dword blkrgn;
  dword blkdst;
  dword nextdst;
  byte pattern[16];


  xwa= (dword)dst;
//<assert object dst>
  xde= (dword)rgn;
//<assert object rgn>
  if(m_word(xde+8)!=0) goto pcerr;
  xbc= (dword)pat;
  xiz= xwa;
  _iy= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto pcincdst;
  xiz= m_dword(xiz);
pcincdst:
  _hl= xbc>>24;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+30)= hl;
  m_word(xsp+28)= hl;
  _hl= xbc>>16;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+26)= hl;
  m_word(xsp+24)= hl;
  _hl= xbc>>8;
  _hl= hl&0xff|hl<<8&0xff00;
  m_word(xsp+22)= hl;
  m_word(xsp+20)= hl;
  _bc= bc&0xff|bc<<8&0xff00;
  m_word(xsp+18)= bc;
  m_word(xsp+16)= bc;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  widthdst= xiy;
  _ix= p_dstx;
  _ix+= m_word(xde); //rgn.x
  _hl= 0x000f;
  _hl&= ix;
  toppos= hl;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz;
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  w= 0x3;
  w&= (byte)bc;
  w+= w;
  w+= w;
  w^= 0x1c;
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto pcblkloopin;
pcblkword:
  if((word)hl<17) goto pconeword;
  if((word)hl>=25) goto pctwoword;
  if(c<8) goto pctwoword;
  c-= 8;
  _hl-= 8;
  xix+= 1;
pconeword:
  xde= gcBit_bit8table;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  xde= widthdst;
  _hl= yheight;
pconeyloop:
  _bc= m_word(xsp+(char)wa);
  _bc^= m_word(xix);
  _bc&= iz;
  m_word(xix)^= bc;
  xix+= xde;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  _hl--; if((word)hl!=0) goto pconeyloop;
  blkcount-= 1;
  if(blkcount==0) goto pcblknext;
pcblkloop:
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
pcblkloopin:
  _wa= w;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xix+= xbc;
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=321) goto pcmulti;
  if((word)hl>=41) goto pcfast;
  if((word)hl<33) goto pcblkword;
  if(c<8) goto pcfast;
  c-= 8;
  _hl-= 8;
  xix+= 1;
pctwoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  xde= widthdst;
  _hl= yheight;
pctwoyloop:
  xbc= m_dword(xsp+(char)wa);
  xbc^= m_dword(xix);
  xbc&= xiz;
  m_dword(xix)^= xbc;
  xix+= xde;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  _hl--; if((word)hl!=0) goto pctwoyloop;
  blkcount-= 1;
  if(blkcount!=0) goto pcblkloop;
pcblknext:
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto pcepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto pcblkexist;
  yheight+= bc;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
pcblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  c= (byte)bc;
  c+= c;
  c+= c;
  w-= c;
  w&= 0x0c;
  w|= 0x10;
  blkcount= hl;
  _hl= toppos;
  goto pcblkloopin;
pcepilogue:
  _hl= 1;
  return(short)hl;
pcfast:
//hl<=320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto pcfword;
pcfdword:
// hl<320AŌ̓_u[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= pcfdyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  c+= c;
  qixh= c;
  _bc= yheight;
  qwa= bc;
  xbc= m_dword(xsp+(char)wa);
pcfdxloop:
  switch(xde) {
  case 9: m_dword(xix+32)= xbc;
  case 8: m_dword(xix+28)= xbc;
  case 7: m_dword(xix+24)= xbc;
  case 6: m_dword(xix+20)= xbc;
  case 5: m_dword(xix+16)= xbc;
  case 4: m_dword(xix+12)= xbc;
  case 3: m_dword(xix+8)= xbc;
  case 2: m_dword(xix+4)= xbc;
  };
pcfdyloop:
  xhl= xbc;
  xbc^= m_dword(xix);
  xbc&= xiy;
  m_dword(xix)^= xbc;
  xhl^= m_dword(xix+(char)qixh);
  xhl&= xiz;
  m_dword(xix+(char)qixh)^= xhl;
  xix+= widthdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  xbc= m_dword(xsp+(char)wa);
  qwa-= 1;
  if(qwa!=0) goto pcfdxloop;
  blkcount-= 1;
  if(blkcount!=0) goto pcblkloop;
  goto pcblknext;
pcfword:
// hl<320AŌ̓[h
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  c= (byte)hl;
  c+= c;
  //_hl+= c;
  //xhl&= 0x0ffff;
  //xde= pcfwyloop + 3;
  //xde-= xhl;
  xde= (word)hl; //1`
  c+= c;
  qixh= c;
  _bc= yheight;
  qwa= bc;
  xbc= m_dword(xsp+(char)wa);
pcfwxloop:
  switch(xde) {
  case 9: m_dword(xix+32)= xbc;
  case 8: m_dword(xix+28)= xbc;
  case 7: m_dword(xix+24)= xbc;
  case 6: m_dword(xix+20)= xbc;
  case 5: m_dword(xix+16)= xbc;
  case 4: m_dword(xix+12)= xbc;
  case 3: m_dword(xix+8)= xbc;
  case 2: m_dword(xix+4)= xbc;
  };
pcfwyloop:
  _hl= bc;
  xbc^= m_dword(xix);
  xbc&= xiy;
  m_dword(xix)^= xbc;
  _hl^= m_word(xix+(char)qixh);
  _hl&= iz;
  m_word(xix+(char)qixh)^= hl;
  xix+= widthdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  xbc= m_dword(xsp+(char)wa);
  qwa-= 1;
  if(qwa!=0) goto pcfwxloop;
  blkcount-= 1;
  if(blkcount!=0) goto pcblkloop;
  goto pcblknext;
pcmulti:
//hl>320
  xde= gcBit_bit8table;
  _hl-= 1;
  if(((word)hl&0x10)==0) goto pcmword;
pcmdword:
//Ōオdword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiz|= 0xffff0000;
#else
  xiz= xiz<<16|0xffff;
#endif
  _hl= (word)hl>>(5+15)%16+1;
  qwa= hl;
  qwa-= 1;
  _hl+= hl;
  _hl+= hl;
  _bc= widthdst; //lower word
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc;
pcmdyloop:
  xde= m_dword(xsp+(char)wa);
  xbc= xde;
  xbc^= m_dword(xix);
  xbc&= xiy;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl= qwa;
pcmdxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xde;
  _hl--; if(hl!=0) goto pcmdxloop;
  xde^= m_dword(xix);
  xde&= xiz;
  m_dword(xix)^= xde;
  xix+= nextdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  qhl--; if(qhl!=0) goto pcmdyloop;
  blkcount-= 1;
  if(blkcount!=0) goto pcblkloop;
  goto pcblknext;
pcmword:
//Ōオword
  c+= c;
  _iy= m_word(xde+(char)c);
#ifdef __BIG_ENDIAN__
  xiy= xiy<<16|0xffff;
#else
  xiy|= 0xffff0000;
#endif
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl= (word)hl>>(5+15)%16+1;
  qwa= hl;
  qwa-= 1;
  _hl+= hl;
  _hl+= hl;
  _bc= widthdst; //lower word
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc;
pcmwyloop:
  xde= m_dword(xsp+(char)wa);
  xbc= xde;
  xbc^= m_dword(xix);
  xbc&= xiy;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl= qwa;
pcmwxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xde;
  _hl--; if(hl!=0) goto pcmwxloop;
  _de^= m_word(xix);
  _de&= iz;
  m_word(xix)^= de;
  xix+= nextdst;
  _wa= wa&0xfff0|(wa-4)&0x0f;
  qhl--; if(qhl!=0) goto pcmwyloop;
  blkcount-= 1;
  if(blkcount!=0) goto pcblkloop;
  goto pcblknext;
pcerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
