// gc::bit c-interface
//   coded by zoro (悵)
// 1997-11-24 write off
// 1998-02-07 changed for ai15
// 2007-06-25 changed

#include "../gc.h"
#include "bit.h"

gcBit*
gcBitAlloc(short w, short h)
{
  gcBit_d* td;
  long size;
  short bytes;
  short rt;
  if(h<0) h= -h;
  if(w>0) {
    bytes= (w+15)/16*2;
    size= bytes*h;
  } else {
    bytes= -((-w+15)/16*2);
    size= -bytes*h;
  };
  size+= 4; //wb_
  size+= 4; //ANZX݂͂
  rt= gcObjAlloc((gcObj**)&td, &size, 0);
  if(rt<0) return 0;
  td->flag= 0; //internal
  td->bytes= bytes;
  return(gcBit*)td;  
};

gcBit*
gcBitAllocAddr(short w, void* addr)
{
  gcBit_d* td;
  long size;
  short bytes;
  short rt;
  if(w>0) {
    bytes= (w+15)/16*2;
  } else {
    bytes= -((-w+15)/16*2);
  };
  size= 8;
  rt= gcObjAlloc((gcObj**)&td, &size, 0); 
  if(rt<0) return 0;
  td->flag= 1; //external
  td->bytes= bytes;
  td->addr= addr;
  return(gcBit*)td;
};

