// gc::bit::copy::tail
//   coded by zoro (悵)
// 1997-11-13 write off, checked
// 1999-02-01 changed for ai15, checked
// 2007-06-22 to .cc using mactocc
//      06-25 checked on litle-endian
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBit_tailin(dword addrdst, word widthdst, dword addrsrc, word widthsrc
, dword addrrgn, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword toprgn;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;
  word slcount;

dmesg("tailin\n");
  xiz= addrdst;
  xbc= addrsrc;
  xde= addrrgn;
  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= iy;
  toppos= hl;
  _hl= (dword)-1;
  _hl+= m_word(xde+2); //rgn.y
  _hl+= m_word(xde+6); //rgn.h
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= hl;
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _hl+= p_dsty;
  xhl= (short)xhl*(short)widthdst;
  xix+= xhl;
  _wa&= 7;
  if((word)wa==0) goto bt8start;
btstart:
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  xde= xde+12;
  xbc&= 0x0ffff;
  _hl= 0;
btstartseek:
  _bc= m_word(xde+2);
  _hl+= 1;
  _bc+= bc;
  _bc+= bc;
  xde+= xbc;
  if((word)hl<m_word(xde)) goto btstartseek;
  slcount= hl;
  goto btblkin;
bt8start:
  xiy-= 2;
  xix-= 2;
  topsrc= xiy;
  topdst= xix;
  xde= xde+12;
  xbc&= 0x0ffff;
  _hl= 0;
bt8startseek:
  _bc= m_word(xde+2);
  _hl+= 1;
  _bc+= bc;
  _bc+= bc;
  xde+= xbc;
  if((word)hl<m_word(xde)) goto bt8startseek;
  slcount= hl;
  goto bt8blkin;
// bit copy tail shifted
btxtailword:
#ifndef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= (xix-= 2,mem= xix,m_word(mem));
  _bc&= iz; //tailmask͂Ă
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto btyloopex;
btyloop:
  xiy-= nextsrc;
  xix-= nextdst;
btyloopin:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#else
  e= (byte)xbc; //Jz
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _bc^= m_word(xix);
  _bc&= qwa; //headmask
  m_word(xix)^= bc;
  _hl= qde; //xcount
  xbc= (xiy-= 4,mem= xiy,m_dword(mem));
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifndef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl+= 2;
  if((short)hl>=0) goto btxloopex;
btxloop:
  (xix-= 4,mem= xix,m_dword(mem))= xbc;
  xbc= (xiy-= 4,mem= xiy,m_dword(mem));
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifndef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl+= 2;
  if((short)hl<0) goto btxloop;
btxloopex:
  if((word)hl!=0) goto btxtailword;
  xbc^= (xix-= 4,mem= xix,m_dword(mem));
  xbc&= xiz; //tailmask
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto btyloop;
btyloopex:
  blkcount-= 1;
  if(blkcount==0) goto btblknext;
btblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //spacewidth
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
btblkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _bc= 0xfff0;
  _bc&= hl;
  _bc= (short)bc>>(3+15)%16+1;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //markwidth
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_nottable+2; //.xde= 398;
  if((short)hl>=-1) goto btoneword;
  if((short)hl<-9) goto btmulti;
  if(c<8) goto btoneword1;
btmulti:
  c+= c; //0:0080 1:00c0 2:00e0 15:ffff
  _bc= m_word(xde+(char)c); //.bc= m_word(xde+(char)c);
  qwa= bc;
  _hl+= 1;
#ifdef __BIG_ENDIAN__
  xiz= m_dword(gcBit_bit8tabletwo+(hl&0x001f)*4);
#else
  c= 0x0f;
  c&= (byte)hl;
  c+= c; //-16:0xffff -15:0xff7f -14:0xff3f .. -1:0x0100
  c+= 32;
  _iz= m_word(xde+(char)c); //.xiz= m_dword(xde+(char)c);
  xiz|= 0xffff0000;
#endif
  _hl= (short)hl>>(4+15)%16+1;
  qde= hl; //xcount(minus)
  _hl+= hl;
  _bc= widthdst;
  _bc+= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _hl&= 0xfffc;
  _bc= widthsrc;
  _bc+= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextsrc= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto btyloopin;
btoneword1:
  xde= xde+16; //somehow tricky
  xix-= 1;
  xiy-= 1;
btoneword:
  c+= c; //0:0080 1:00c0 2:00e0 15:ffff
  _iz= m_word(xde+(char)c);
  _hl+= hl; //-1:0000 0:0080 ... 14:feff
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
btoneyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#else
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _bc^= m_word(xix);
  _bc&= iz; //masksrc
  m_word(xix)^= bc;
  xiy-= xhl;
  xix-= xde;
  qwa--; if(qwa!=0) goto btoneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto btblkloop;
btblknext:
//̃XCX
  slcount-= 1;
  if((short)slcount<=0) goto btepilogue;
  xde= toprgn;
  _bc= m_word(xde);
  if((short)m_word(xde-4)>=0) goto btblkexist;
  slcount-= 1;
  xde-= 4; _bc+= m_word(xde);
btblkexist:
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
btblkin:
  _hl= toppos;
  xhl&= 0x0ffff;
  xiz= xde;
  xbc= (xiz-= 4,mem= xiz,m_dword(mem));
btblkseek:
  xhl+= xbc;
  xbc= (xiz-= 4,mem= xiz,m_dword(mem));
  if((short)m_word(xiz)>=0) goto btblkseek; //rewrite for bi-endian
  toprgn= xiz;
  _hl= (word)hl+(xhl>>16); //hl for lastpos
  _bc= 0;
  _bc-= m_word(xiz);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xiz+2);
  blkcount= bc;
  _hl-= 1;
  goto btblkloopin;
// bit copy forward aligned
bt8multi:
  xde= gcBit_nottable+2;
  c+= c;
  _wa= m_word(xde+(char)c);
  _hl+= 1;
  c= 0x0f;
  c&= (byte)hl;
  c+= c;
  c+= 32;
  _bc= m_word(xde+(char)c);
  qbc= bc;
  _hl= (short)hl>>(3+15)%16+1;
  _hl= ~hl;
  _hl&= 0xfffe;
  _iz= widthsrc;
  _iz-= hl;
  if(xiz&0x08000) xiz|= 0xffff0000; else xiz&= 0x0ffff;
  _de= widthdst;
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _hl= (short)hl>>(1+15)%16+1;
  _bc= yheight;
  qhl= bc;
  dmesg("%d+%d < %d+%d %04x(%d)%04x x%d\n", xix, xde, xiy, xiz, wa, hl, qbc, qhl);
bt8yloop:
  _bc= m_word(xiy+2);
  _bc^= m_word(xix+2);
  _bc&= wa; //headmask
  m_word(xix+2)^= bc;
  _bc= hl; //xcount
  do { m_word(xix)= m_word(xiy);
       xix-= 2; xiy-= 2; } while(--_bc, (word)bc);
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= qbc; //tailmask
  m_word(xix)^= bc;
  xiy-= xiz;
  xix-= xde;
  qhl--; if(qhl!=0) goto bt8yloop;
  qwa-= 1;
  if(qwa==0) goto bt8blknext;
bt8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //spacewidth
// xix=dest xiy=src xde=rgn hl=prev-xe
bt8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _bc= 0xfff0;
  _bc&= hl;
  _bc= (short)bc>>(3+15)%16+1;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl-= (xde-= 2,mem= xde,m_word(mem)); //markwidth
  blkrgn= xde; //save
  xposition= hl; //save
  if((short)hl<-25) goto bt8multi;
  if((short)hl>=-17) goto bt8blkword;
  if(c>=8) goto bt8multi;
  c+= 8;
  _hl+= 8;
  xiy-= 1;
  xix-= 1;
bt8twoword:
  xde= gcBit_bit8tabletwo+17*4;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(char)hl); //.xiz= m_dword(xde+(char)l);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c); //.xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
bt8twoyloop:
  xbc= m_dword(xiy);
  xbc^= m_dword(xix);
  xbc&= xiz; //mask
  m_dword(xix)^= xbc;
  xiy-= xhl;
  xix-= xde;
  _wa--; if((word)wa!=0) goto bt8twoyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto bt8blkloop;
  goto bt8blknext;
bt8blkword:
  if((char)hl>=-1) goto bt8oneword;
  if((char)hl<-9) goto bt8twoword;
  if(c>=8) goto bt8twoword;
  c+= 8;
  _hl+= 8;
  xiy-= 1;
  xix-= 1;
bt8oneword:
  xde= gcBit_bittable+2;
  _hl+= hl;
  _iz= m_word(xde+(char)hl); //.iz= m_word(xde+(char)l);
  c+= c;
  _iz^= m_word(xde+(char)c); //.iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  xiy+= 2;
  xix+= 2;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
bt8oneyloop:
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= iz; //mask
  m_word(xix)^= bc;
  xiy-= xhl;
  xix-= xde;
  _wa--; if((word)wa!=0) goto bt8oneyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto bt8blkloop;
bt8blknext:
//̃XCX
  slcount-= 1;
  if((short)slcount<=0) goto btepilogue;
  xde= toprgn;
  _bc= m_word(xde);
  if((short)m_word(xde-4)>=0) goto bt8blkexist;
  slcount-= 1;
  xde-= 4; _bc+= m_word(xde);
bt8blkexist:
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
bt8blkin:
  _hl= toppos;
  xhl&= 0x0ffff;
  xiz= xde;
  xbc= (xiz-= 4,mem= xiz,m_dword(mem));
bt8blkseek:
  xhl+= xbc;
  xbc= (xiz-= 4,mem= xiz,m_dword(mem));
  if((short)m_word(xiz)>=0) goto bt8blkseek; //rewrite for bi-endian
  toprgn= xiz;
  _hl= (word)hl+(xhl>>16); //hl for lastpos
  _bc= 0;
  _bc-= m_word(xiz);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xiz+2);
  qwa= bc;
  _hl-= 1;
  goto bt8blkloopin;
btepilogue:
  _hl= 1;
  return(short)hl;
};
