// gc::bit::copy::xornot
//   coded by zoro (悵)
// 1997-11-14 write off, checked
// 1999-02-02 changed for ai15, checked
// 2007-06-26 from ornot.cc
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitXorNot( gcBit* dst, gcBit* src, gcRgn* rgn
, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word widthsrc;
  word widthdst;
  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;

  xwa= (dword)dst;
//<assert object>
  xbc= (dword)src;
//<assert object>
  xde= (dword)rgn;
//<assert object>
  if(m_word(xde+8)!=0) goto nxcopyerr;
  widthsrc= m_word(xbc+2);
  xbc+= 4;
  if(m_word(xbc-4)==0) goto nxincsrc;
  xbc= m_dword(xbc);
nxincsrc:
  xiz= xwa;
  widthdst= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto nxincdst;
  xiz= m_dword(xiz);
nxincdst:

  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= 0;
  _wa-= iy;
  toppos= hl;
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  _wa&= 7;
  if((word)wa==0) goto nx8start;
nxstart:
  xiy-= 1;
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto nxblkloopin;
nx8start:
  topsrc= xiy;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  qwa= bc;
  xde= xde+16;
  goto nx8blkloopin;
// not xor shifted
nxxtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc&= iz; //tailmask
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto nxyloopex;
nxyloop:
  xiy+= nextsrc;
  xix+= nextdst;
nxyloopin:
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifdef __BIG_ENDIAN__
  e= (byte)xbc;
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#endif
  _bc&= qwa; //headmask
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _hl= qde; //xcount
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl<=0) goto nxxloopex;
nxxloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl>0) goto nxxloop;
nxxloopex:
  if((short)hl<0) goto nxxtailword;
  xbc&= xiz; //tailmask
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto nxyloop;
nxyloopex:
  blkcount-= 1;
  if(blkcount==0) goto nxblknext;
nxblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
nxblkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_bittable;
  if((word)hl<17) goto nxoneword;
  if((word)hl>=25) goto nxmulti;
  if(c>=8) goto nxoneword1;
nxmulti:
  c+= c;
  _bc= m_word(xde+(char)c);
  qwa= bc;
  _hl-= 1;
#ifdef __BIG_ENDIAN__
  xiz= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xiz= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  qde= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  _bc+= 2;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto nxyloopin;
nxoneword1:
  xde= xde-16; //somehow tricky
  xix+= 1;
  xiy+= 1;
nxoneword:
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl+= hl;
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
nxoneyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#endif
  _bc= ~bc;
  _bc&= iz; //masksrc
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  qwa--; if(qwa!=0) goto nxoneyloop;
  blkcount-= 1;
  if(blkcount!=0) goto nxblkloop;
nxblknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto nxepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto nxblkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
nxblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  blkcount= hl;
  _hl= toppos;
  goto nxblkloopin;
// bit xor aligned
nx8multi:
  xde= gcBit_bittable;
  _hl-= 17;
#ifdef __BIG_ENDIAN__
  xiz= m_word(xde+c*2)<<16|0xffff;
  xde= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c+= c;
  _iz= m_word(xde+(char)c);
  xiz|= 0xffff0000;
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xde= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  _wa= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  goto nx8yloopin;
nx8xtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc&= de;
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto nx8yloopex;
nx8yloop:
  xiy+= nextsrc;
  xix+= nextdst;
nx8yloopin:
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  xbc&= xiz;
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  _hl= wa;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl<=0) goto nx8xloopex;
nx8xloop:
  (mem= xix,xix+= 4,m_dword(mem))^= xbc;
  xbc= 0xffffffff;
  xbc^= (mem= xiy,xiy+= 4,m_dword(mem));
  _hl-= 2;
  if((short)hl>0) goto nx8xloop;
nx8xloopex:
  if((short)hl<0) goto nx8xtailword;
  xbc&= xde;
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto nx8yloop;
nx8yloopex:
  qwa-= 1;
  if(qwa==0) goto nx8blknext;
nx8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe
nx8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=41) goto nx8multi;
  if((word)hl<33) goto nx8blkword;
  if(c<8) goto nx8multi;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
nx8twoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
nx8twoyloop:
  xbc= 0xffffffff;
  xbc^= m_dword(xiy);
  xbc&= xiz; //mask
  m_dword(xix)^= xbc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto nx8twoyloop;
  qwa-= 1;
  if(qwa!=0) goto nx8blkloop;
  goto nx8blknext;
nx8blkword:
  if((word)hl<17) goto nx8oneword;
  if((word)hl>=25) goto nx8twoword;
  if(c<8) goto nx8twoword;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
nx8oneword:
  xde= gcBit_bittable;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
nx8oneyloop:
  _bc= m_word(xiy);
  _bc= ~bc;
  _bc&= iz; //mask
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto nx8oneyloop;
  qwa-= 1;
  if(qwa!=0) goto nx8blkloop;
nx8blknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto nxepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto nx8blkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
nx8blkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  qwa= hl;
  _hl= toppos;
  goto nx8blkloopin;
nxepilogue:
  _hl= 1;
  return(short)hl;
nxcopyerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};
