/* wb_t@C */
#if !defined(__GC_H)
#define __GC_H
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned long dword;

typedef void gcObj;
typedef void gcRgn;
typedef void gcBit;

// gcHeap q[v̈ǗNX
#define gcHeap_HEAD      1
#define gcHeap_ALL       2
#define gcHeap_LOWEST    4
#define gcHeap_NOCOMPACT 8
#define gcHeap_NOMOVE   16
     void gcHeapMemMove(void* to, void* from, long len);

// gcObj IuWFNgNX
    short gcObjAlloc(gcObj** obj, long* size, short mode);
    short gcObjRealloc(gcObj** obj, long* size, short mode);
     void gcObjFree(gcObj* obj);
//   long gcObjSize(gcObj* obj);

// gcRgn ̈NX
   gcRgn* gcRgnRect(short x, short y, short w, short h, short inv);
#define   gcRgnFree(A) gcObjFree((gcObj*)(A))
#define   gcRgnGetMode(A) (((short*)(A)->d)[4])
   gcRgn* gcRgnAnd(gcRgn*a, gcRgn*b, short ax, short ay, short bx, short by);
   gcRgn* gcRgnDiff(gcRgn*a, gcRgn*b, short ax, short ay, short bx, short by);
   gcRgn* gcRgnOr(gcRgn*a, gcRgn*b, short ax, short ay, short bx, short by);
     long gcRgnSize(gcRgn*);
     void gcRgnMove(gcRgn* t, short x, short y, short inv);
   gcRgn* gcRgnDup(gcRgn* a, short x, short y, short inv);
    short gcRgnIfRect(gcRgn*, short x, short y, short w, short h);

// gcBit rbg}bvNX
   gcBit* gcBitAlloc(short w, short h);
   gcBit* gcBitAllocAddr(short w, void* addr);
#define   gcBitFree(A) gcObjFree((gcObj*)(A))
    short gcBitMove( gcBit* d, gcBit* s, gcRgn* rgn
          , short dx, short dy, short sx, short sy);
    short gcBitCopy( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitCopyNot( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitAnd( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitAndNot( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitOr( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitOrNot( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitXor( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitXorNot( gcBit*, gcBit*, gcRgn*, short, short, short, short);
    short gcBitClear( gcBit* d, gcRgn* rgn, short dx, short dy);
    short gcBitFill( gcBit* d, gcRgn* rgn, short dx, short dy);
    short gcBitInvert( gcBit* d, gcRgn* rgn, short dx, short dy);
    short gcBitFillPat( gcBit* d, dword pat, gcRgn* rgn, short dx, short dy);
    short gcBitAndPat( gcBit* d, dword pat, gcRgn* rgn, short dx, short dy);
    short gcBitOrPat( gcBit* d, dword pat, gcRgn* rgn, short dx, short dy);
    short gcBitXorPat( gcBit* d, dword pat, gcRgn* rgn, short dx, short dy);
    short gcBitCopyMask( gcBit* d, gcBit* s, dword mask, gcRgn* rgn
          , short dx, short dy, short sx, short sy);
    short gcBitDisplay( gcBit* s, gcRgn* rgn
          , short dx, short dy, short sx, short sy);

#endif
