// gc::heapc routine
//   coded by 悵
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../gc.h"
#include "heap.h"

short gcObjAlloc(gcObj** ptr, long *sz, short mode)
{
  void *a;
  a= malloc(*sz);
  dmesg("Alloc %x %d\n", a, *sz);
  if(a==0) return -1;
  *ptr= a;  
  return 0;
};

short gcObjRealloc(gcObj** ptr, long *sz, short mode)
{
  void *a;
  a= realloc(*ptr, *sz);
  dmesg("Realloc %x %d (%x)\n", a, *sz, *ptr);
  if(a==0) return -1;
  *ptr= a;
  return 0;
};

void gcObjFree(gcObj* obj)
{
  dmesg("Free %x\n", obj);
  free(obj);
};

void gcHeapMemMove(void* to, void* from, long len)
{
  memcpy(to, from, len);
};
