// gc::rgn::diff routine
//   coded by 悵
// 1997-09-04 begin
//      09-05 write off (w/o memory mgr and thunk)
//      09-10 to .mac
//      11-03 inv height
//      11-23 w/ memory mgr
// 2007-06-13 to .cc using mactocc
//      06-19 checked

#include <stdio.h>
#include "../gc.h"
#include "rgn.h"

short gcRgnDiffCore(gcRgn** prgnt, long sizet, gcRgn* rgna, gcRgn* rgnb
, short posax, short posay, short posbx, short posby)
{
#include "../tlcs900.h"
  word qhl;

  word alloced;
  dword areat, areaa, areab;
  dword prevt, currt, curra, currb;
  word heighta, heightb;
  word offsetb, minx;

//get alloced size
  xde= *(dword*)prgnt;
  xhl= sizet;
  xhl>>= (2+15)%16+1;
  _hl-= 4;
  alloced= hl;
  areat= xde; //keep address for block-move check
  xiy= (dword)rgna;
  areaa= xiy;
  xiz= (dword)rgnb;
  areab= xiz;
  xbc= 0; //for qbc=0
//diff̏ꍇ̓oE_N^OJn_͉A傫͂Ƃ
  _ix= posax;
  m_word(xde)= ix;
  _ix-= posbx;
  offsetb= ix; //flag continues
  if((short)ix<0) goto diffpxbigb;
diffpxbiga:  
  if((short)ix<*(short*)m(xiz+4)) goto diffpxcont;
  goto diffcopy;
diffpxbigb: //ix͕̐
  _ix+= m_word(xiy+4); //a.w -> VF=0
  if((short)ix<=0) goto diffcopy;
diffpxcont:
  _ix= posay;
  m_word(xde+2)= ix; //d.y=a.y;
  _ix-= posby;
  if((word)ix==0) goto diffpysame; //ꏊ
  if((short)ix<0) goto diffpybigb;
diffpybiga: // a.y>b.y ix͍()
  dmesg("pybiga\n");
  if((short)ix>=*(short*)m(xiz+6)) goto diffcopy;
  _hl= m_word(xiy+12); //a[0].h
  heighta= hl;
  xiy= xiy+16; //a=ŏ̃ubN
  xiz= xiz+16; //b=ŏ̃ubN
  _ix+= m_word(xiz-4); //height
  if((short)ix<0) goto diffpyabrk;
diffpyaloop:
  _bc= m_word(xiz-2); //num
  _bc+= bc;
  _bc+= bc;
  xiz+= (word)bc;
  _ix+= m_word(xiz-4); //height
  if((short)ix>=0) goto diffpyaloop;
diffpyabrk:
  heightb= ix;
  goto diffpycont;
diffpysame://a.y==b.y
  _ix= m_word(xiy+12); //a[0].h
  heighta= ix;
  _hl= m_word(xiz+12); //b[0].h
  heightb= hl;
  xiy= xiy+16; //a=ŏ̃ubN
  xiz= xiz+16; //b=ŏ̃ubN
  goto diffpycont;
diffpybigb:// b.y>a.y ix͕
  dmesg("pybigb\n");
  heightb= ix;
  _ix+= m_word(xiy+6);
  if((short)ix<=0) goto diffcopy;
  _ix= m_word(xiy+12); //a[0].h
  heighta= ix;
  xiy= xiy+16; //a=ŏ̃ubN
  xiz= xiz+12; //b=̃ubN
//jr  diffpycont
diffpycont://height͂Ƃŋ߂
  xwa= 0x10000;
  m_word(xde+8)= xwa; m_word(xde+10)= xwa>>16;//(xde+8)͂Ƃd.yɉ
  xde= xde+12;
  prevt= xde;
  xde+= 4; //t=ŏ̃ubN
  currt= xde;
  curra= xiy;
  currb= xiz;
  minx= 0xffff;
  goto diffyloop;
differror:
  _hl= (word)-1;
  *(dword*)prgnt= areat;
  return(short)hl;

diffallocbc:
  _ix= bc;
diffalloc:
  _ix+= 4; //Œ1+]3
  _ix+= ix;
  _ix+= ix;
  xix&= 0xffff;
  xix+= xde;
  xiz= areat;
  xix-= xiz;
  xwa= areat;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xix, 2);
  if((short)hl<0) goto differror;
  xhl= xix; //new ObjSize
  xhl&= 0xfffffffc;
  xhl+= xiz;
  xhl-= currt;
  xhl>>= (2+15)%16+1;
  alloced= hl;
  xde= xwa; //new address
  xde-= xiz; //difference
  areat= xwa;
  prevt+= xde;
  xde+= currt;
  currt= xde;
  //areaa/areab unchanged
  xiy= curra;
  xiz= currb;
  xbc= 0;
// diff y core
// assign: xiy=curra(mustsaved)
//         xiz=currb(mustsaved)
//         xde=currt(mustsaved), prevt need
//         qbc=(constant)0
diffyloop:
  dmesg("xiy=%d xiz=%d xde=%d prevt=%d heighta=%d heightb=%d\n"
  ,xiy-areaa, xiz-areab, xde-areat, prevt-areat, heighta, heightb);
  _bc= 0xffff;
  _bc+= m_word(xiy-2); //a.n
  if((word)bc==0) goto diffxnoa;
  _ix= 0xffff;
  _ix+= m_word(xiz-2); //b.n
  if((word)ix==0) goto diffxnob;
  qhl= ix;
  _ix+= bc;
  
  if((word)ix>=alloced) goto diffalloc;
  _ix= 0;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  _hl= offsetb;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  _wa= 0;
  goto diffx00;
diffxnoa:  
  if((word)bc>=alloced) goto diffallocbc;
  _bc= 0xffff;
  _bc+= m_word(xiz-2);
  _bc+= bc;
  _bc+= bc;
  xiz+= (word)bc;
//jr  diffxendn
diffxendn://xde,xiy,xiz L, ubNȂ
  dmesg("endn:xiy=%d xiz=%d xde=%d prevt=%d\n"
  , xiy-areaa, xiz-areab, xde-areat, prevt-areat);
  xde+= 4;
  _bc= 1;
  m_word(xde-6)= bc; //t.n
  alloced-= bc;
  xhl= prevt;
  
  if((word)bc==*(word*)m(xhl-2)) goto diffxmatch;
  xix= currt;
  goto diffxdiff2;
diffxnob:
  if((word)bc>=alloced) goto diffallocbc;
// offseta0Ȃ̂ł̂܂܃Rs[
  _bc+= bc;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
//jr  diffxend
diffxend:// xde,xiy,xiz L, ubN
  dmesg("end: xiy=%d xiz=%d xde=%d prevt=%d\n"
  , xiy-areaa, xiz-areab, xde-areat, prevt-areat);
  xde+= 4;
  xix= currt;
  _bc= de;
  _bc-= ix;
  _bc= (word)bc>>((2+15)%16+1);
  m_word(xix-2)= bc; //t.n
  alloced-= bc;
  xhl= prevt;
  
  if((word)bc!=*(word*)m(xhl-2)) goto diffxdiff;
  _bc-= 1;
diffxcmp:
  xwa= (mem= xhl,xhl+= 4,m_dword(mem));
  xix+= 4; if(xwa!=*(dword*)m(xix-4)) goto diffxdiff;
  _bc--; if((word)bc!=0) goto diffxcmp;
diffxmatch://need xhl
  dmesg("match\n");
  xix= prevt;
  _bc= m_word(xix-2);
  alloced+= bc;
  _wa= m_word(xix-4);
  xde= xhl+4;
  goto diffynext;
diffxdiff://ubNȂdiffxdiff2
  xix= currt;
//ŏxlL^
  _bc= m_word(xix);
  if((word)bc>=minx) goto diffxdiff2; /*NC*/
  minx= bc;
diffxdiff2:
  prevt= xix;
  currt= xde;
  _wa= 0;
diffynext:
  _hl= heighta;
  _bc= heightb;
//xix:currt, xiy:next(curra)-4, xiz:next(currb)-4, xde:nextt
  if((word)hl==(word)bc) goto diffyabnext;
  if((word)hl<(word)bc) goto diffybnext;
diffyanext://a
  heightb-= hl;
  _wa+= hl;
  m_word(xix-4)= wa;
  xiz= currb; //a͂߂āAb͖߂
  _hl= 0;
  _hl+= *(word*)m(xiy); xiy+= 4;
  curra= xiy; //tOێ
  heighta= hl; //tOێ
  if((short)hl<0) goto diffyloop;
  goto difffinish;
diffybnext://b
  heighta-= bc;
  _wa+= bc;
  m_word(xix-4)= wa;
  xiy= curra; //b͂߂āAa͖߂
  _bc= *(word*)m(xiz); xiz+= 4;
  currb= xiz;
  heightb= bc;
  goto diffyloop; //aI܂ŏIȂ
diffyabnext://ab
  _wa+= bc;
  m_word(xix-4)= wa;
  _bc= *(word*)m(xiz); xiz+= 4;
  currb= xiz;
  heightb= bc;
  _hl= 0;
  _hl+= *(word*)m(xiy); xiy+= 4;
  curra= xiy; //tOێ
  heighta= hl; //tOێ
  if((short)hl<0) goto diffyloop;
//goto difffinish;
difffinish:
  _iz= 0;
  _iz+= minx;
  if((short)minx<0) goto diffempty;
//̋ubNJbg(ő1)
  xix= prevt;
  
  if(*(word*)m(xix-2)!=1) goto difffincode;
  dmesg("lastcut\n");
  xde= xix;
  alloced+= 1;
difffincode:
  xwa= 0x10000;
  m_word(xde-4)= xwa; m_word(xde-2)= xwa>>16;
//]Ȋmۃ
  xde-= areat;
  xwa= areat;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xde, 16);
  areat= xwa;
//oE_NǧvZ
  xde= areat;
  xhl= xde; //ۑ
  _wa= m_word(xde+8); //ŏ̖ubN()
  m_word(xde+8)= 0;
  m_word(xde+2)-= wa; //t.y
  m_word(xde)+= iz; //t.x
  xde= xde+12;
// trim core
//  in: iz=minx xde=ŏ̃ubN̐擪(heighẗʒu)
// out: ix=width,iy=height
  _ix= 0;
  _iy= 0;
difftrimyn:
  _iy-= (mem= xde,xde+= 2,m_word(mem));
  if(*(word*)m(xde-2)==0) goto difftrime;
difftrimyl:
  _bc= 0xffff;
  _bc+= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto difftrimyn;
  m_word(xde)-= iz;
  xwa= 0;
difftrimxl:
  xwa+= (mem= xde,xde+= 4,m_dword(mem));
  _bc--; if((word)bc!=0) goto difftrimxl;
  _wa= (xwa&0xffff)+(xwa>>16);
  
  if((short)ix>=(short)wa) goto difftrimyn;
difftrimym:
  _ix= wa;
  _iy-= (mem= xde,xde+= 2,m_word(mem));
  if(*(word*)m(xde-2)!=0) goto difftrimyl; /*NC*/
difftrime:
  m_word(xhl+4)= ix; //width
  m_word(xhl+6)= iy; //height
  _hl= 0;
  *(dword*)prgnt= areat;
  return(short)hl;
diffempty:
  xwa= areat;
  xde= 10;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xde, 16); //gcHeap_NOMOVE
  areat= xwa;
  xde= areat;
  xwa= 0;
  m_dword(xde)= xwa;
  m_dword(xde+4)= xwa;
  m_word(xde+8)= 1;
  _hl= 1;
  *(dword*)prgnt= areat;
  return(short)hl;

diffcopy:
// check xiy length
  xiz= xiy+12;
  _hl= 0; //qbc may 0
diffcopyl:
  _bc= m_word(xiz+2);
  _bc+= bc;
  _bc+= bc;
  xiz+= (word)bc;
  if((word)hl<*(word*)m(xiz)) goto diffcopyl;
  xiz-= xiy;
  xiz+= 4;
  xwa= areat;
  xbc= xiz;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xiz, 0);
  if((short)hl<0) goto differror;
  areat= xwa;
  xix= areat;
  xiy= areaa;
  m_word(xix)= posax; m_word(xix+2)= posay;
  xwa= m_dword(xiy+4);
  m_dword(xix+4)= xwa;
  m_word(xix+8)= 0;
  xiy= xiy+10;
  xix= xix+10;
  xbc>>= (1+15)%16+1;
  _bc-= 5;
  do { *(word*)m(xix)= *(word*)m(xiy);
       xix+= 2; xiy+= 2; } while(--_bc, (word)bc);
  _hl= 0;
  *(dword*)prgnt= areat;
  return(short)hl;

// diff x core
// assign qbc=0
//        a: ix=-1-Xa, pointer:xiy, counter:bc
//        b: hl=-1-Xb, pointer:xiz, counter:qhl
//        t: wa=Xlast, pointer:xde
//      out: xiy, xiz, xde
// not used: qwa, qbc=0, qix
// entry point: diffx00
//     exit: diffxend or diffxendn(no block)
diffx0001:
// next Xb
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
diffx01:
  if((short)hl<(short)ix) /*lt*/ goto diffx0111;
// next-check Xb
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  qhl--; if(qhl!=0) goto diffx00;
  xiz-= 2;
diffx0100e:// XaRs[
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc+= bc;
  _bc-= 1;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
  goto diffxend;
diffx1000:// end-check-next Xa
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= ix;
  _bc-= 1; //tO
  if((word)bc==0) goto diffx1000e;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
diffx00:  
  if((short)hl>=(short)ix) goto diffx0001;
// start-next Xa
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= ix;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  goto diffx10;
diffx0111:// next Xa
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
diffx11:
  if((short)ix<(short)hl) goto diffx1110;
// next-check Xa
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  _bc--; if((word)bc!=0) goto diffx01;
  xiy-= 2;
diffx1101e:// Xbi߂
  _bc= 0xffff;
  _bc+= qhl;
  _bc+= bc;
  _bc+= bc;
  xiz+= (word)bc;
  if((word)de!=(word)currt) goto diffxend;
  goto diffxendn; //endn͂̃p^[̂
diffx1110:// start-check-next Xb
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= hl;
  qhl-= 1;
  if(qhl==0) goto diffx1110e;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
diffx10:
  if((short)ix>=(short)hl) goto diffx1000;
// end-next Xb
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= hl;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  goto diffx11;
diffx1000e:// bi߂
  _bc= qhl;
  _bc+= bc;
  _bc-= 1;
  _bc+= bc;
  xiz+= (word)bc;
  goto diffxend;
diffx1110e:// XaRs[
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc-= 1;
  if((word)bc==0) goto diffxend;
  _bc+= bc;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
  goto diffxend;
};
