// gc::rgn::or routine
//   coded by 悵
// 1997-05-01 begin
// 1997-07-18 restart
//      08-29 write off (w/o memory mgr and thunk)
//      09-10 to .mac
//      11-03 inv height
//      11-23 w/ memory mgr
// 2007-06-13 to .cc using mactocc
//      06-19 checked

#include <stdio.h>
#include "../gc.h"
#include "rgn.h"

short gcRgnOrCore(gcRgn** prgnt, long sizet, gcRgn* rgna, gcRgn* rgnb
, short posax, short posay, short posbx, short posby)
{
#include "../tlcs900.h"
  word qhl;

  word alloced;
  dword areat, areaa, areab;
  dword prevt, currt, curra, currb;
  word heighta, heightb;
  word offseta, offsetb;

//get alloced size
  xde= *(dword*)prgnt;
  xhl= sizet;
  xhl>>= (2+15)%16+1;
  _hl-= 4;
  alloced= hl;
  areat= xde; //keep address for block-move check
  xiy= (dword)rgna;
  areaa= xiy;
  xiz= (dword)rgnb;
  areab= xiz;
//oȑꍇ̓oE_N^OŏɌ
  _ix= posax;
  _hl= posbx;
  offseta= 0;
  offsetb= 0;
  if((short)ix<(short)hl) goto orpxbigb;
orpxbiga://a.x>=b.x
  m_word(xde)= hl; //t.x
  _ix-= hl;
  offseta-= ix;
  _hl= m_word(xiz+4); //b.w
  _ix+= m_word(xiy+4); //a.w
  goto orpxcont;
orpxbigb://a.x<b.x
  m_word(xde)= ix; //t.x
  _hl-= ix;
  offsetb-= hl;
  _ix= m_word(xiy+4); //a.w
  _hl+= m_word(xiz+4); //b.w
orpxcont:
  if((short)ix<(short)hl) goto orwxbigb;
  _hl= ix;
orwxbigb:
  m_word(xde+4)= hl; //t.w
  _ix= posay;
  _hl= posby;
  if((word)ix==(word)hl) goto orpysame; //ꏊ
  if((short)ix<(short)hl) goto orpybigb;
orpybiga://a.y>b.y
  m_word(xde+2)= hl; //d.y
  _hl-= ix;
  heighta= hl;
  _ix= m_word(xiz+12); //b[0].h
  heightb= ix;
  _hl= -hl;
  _hl+= m_word(xiy+6); //a.h
  _ix= m_word(xiz+6); //b.h
  xiy= xiy+12; //a=̃ubN
  xiz= xiz+16; //b=ŏ̃ubN
  goto orpycont;
orpysame://a.y==b.y
  m_word(xde+2)= ix; //d.y
  _ix= m_word(xiy+12); //a[0].h
  heighta= ix;
  _hl= m_word(xiz+12); //b[0].h
  heightb= hl;
  _ix= m_word(xiy+6); //a.h
  _hl= m_word(xiz+6); //b.h
  xiy= xiy+16; //a=ŏ̃ubN
  xiz= xiz+16; //b=ŏ̃ubN
  goto orpycont;
orpybigb://a.y<b.y
  m_word(xde+2)= ix; //d.y
  _ix-= hl;
  heightb= ix;
  _hl= m_word(xiy+12); //a[0].h
  heighta= hl;
  _ix= -ix;
  _ix+= m_word(xiz+6); //b.h
  _hl= m_word(xiy+6); //a.h
  xiy= xiy+16; //a=ŏ̃ubN
  xiz= xiz+12; //b=̃ubN
//jr  orpycont
orpycont:
  if((short)ix<(short)hl) goto orwybigb;
  _hl= ix;
orwybigb:
  m_word(xde+6)= hl; //d.h
  xwa= 0x10000;
  m_word(xde+8)= xwa; m_word(xde+10)= xwa>>16; //flag and start code
  xde= xde+12;
  prevt= xde;
  xde+= 4; //t=ŏ̃ubN
  currt= xde;
  curra= xiy;
  currb= xiz;
  goto oryloop;
orerror:
  _hl= (word)-1;
  *(dword*)prgnt= areat;
  return(short)hl;

orallocbc:
  _ix= bc;
oralloc:
  _ix+= 4; //Œ1+]3
  _ix+= ix;
  _ix+= ix;
  xix&= 0xffff;
  xix+= xde;
  xiz= areat;
  xix-= xiz;
  xwa= areat;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xix, 2);
  if((short)hl<0) goto orerror;
  xhl= xix; //new ObjSize
  xhl&= 0xfffffffc;
  xhl+= xiz;
  xhl-= currt;
  xhl>>= (2+15)%16+1;
  alloced= hl;
  xde= xwa; //new address
  xde-= xiz; //difference
  areat= xwa;
  prevt+= xde;
  xde+= currt;
  currt= xde;
  //areaa/areab unchanged
  xiy= curra;
  xiz= currb;

// or y core
// assign: xiy=curra(mustsaved)
//         xiz=currb(mustsaved)
//         xde=currt(mustsaved), prevt need
oryloop:
  dmesg("xiy=%d xiz=%d xde=%d prevt=%d heighta=%d heightb=%d\n"
  ,xiy-areaa, xiz-areab, xde-areat, prevt-areat, heighta, heightb);
  _bc= 0xffff;
  _bc+= m_word(xiy-2);
  if((word)bc==0) goto orxnoa;
  _ix= 0xffff; //
  _ix+= m_word(xiz-2);
  if((word)ix==0) goto orxnob;
  qhl= ix;
  _ix+= bc;
  
  dmesg("oryloop x%x x%x x%x\n", ix, bc, alloced);
  if((word)ix>=alloced) goto oralloc;
  _ix= offseta;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  _hl= offsetb;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  _wa= 0;
  goto orx00;
orxnob:
  dmesg("orxnob x%x x%x\n", bc, alloced);
  if((word)bc>=alloced) goto orallocbc;
  _ix= (mem= xiy,xiy+= 2,m_word(mem));
  _ix-= offseta;
  (mem= xde,xde+= 2,m_word(mem))= ix;
  _bc+= bc;
  _bc-= 1;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
  goto orxend;
orxnoa:
  _bc= 0xffff;
  _bc+= m_word(xiz-2);
  dmesg("orxnoa x%x x%x\n", bc, alloced);
  if((word)bc==0) goto orxnothing;
  if((word)bc>=alloced) goto orallocbc;
  _ix= (mem= xiz,xiz+= 2,m_word(mem));
  _ix-= offsetb;
  (mem= xde,xde+= 2,m_word(mem))= ix;
  _bc+= bc;
  _bc-= 1;
  xhl= xiz;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiz= xhl;
//jr  orxend
orxend://xde,xiy,xiz L, bc=0, ubN
  dmesg("end: xiy=%d xiz=%d xde=%d prevt=%d\n"
  , xiy-areaa, xiz-areab, xde-areat, prevt-areat);
  xde+= 4;
  xix= currt;
  _bc= de;
  _bc-= ix;
  _bc= (word)bc>>((2+15)%16+1);
  m_word(xix-2)= bc;
  alloced-= bc;
  xhl= prevt;
  if((word)bc!=*(word*)m(xhl-2)) goto orxdiff;
  _bc-= 1;
orxcmp:
  xwa= (mem= xhl,xhl+= 4,m_dword(mem));
  xix+= 4; if(xwa!=*(dword*)m(xix-4)) goto orxdiff;
  _bc--; if((word)bc!=0) goto orxcmp;
orxmatch://need xhl
  dmesg("match\n");
  xix= prevt;
  _bc= m_word(xix-2);
  alloced+= bc;
  _wa= m_word(xix-4);
  xde= xhl+4;
  goto orynext;

orxnothing://bc=0 (jr폜ɂ肱Ɉړ)  
  if((word)bc>=alloced) /*bc==0*/ goto orallocbc;
//jr  orxendn
orxendn://xde,xiy,xiz L, bc= 0, 
  dmesg("endn:xiy=%d xiz=%d xde=%d prevt=%d\n"
  , xiy-areaa, xiz-areab, xde-areat, prevt-areat);
  xde+= 4;
  _bc= 1; //b  0 
  m_word(xde-6)= bc; //t.n
  alloced-= bc;
//jr  orxdiff	;orł͘AubN͂肦Ȃ
orxdiff:
  xix= currt;
  prevt= xix;
  currt= xde;
  _wa= 0;
orynext:
  _hl= heighta;
  _bc= heightb;
//xix:currt, xiy:next(curra)-4, xiz:next(currb)-4, xde:nextt
  if((word)hl==(word)bc) goto oryabnext;
  if((word)hl<(word)bc) goto orybnext;  //KȂ
oryanext://a
  heightb-= hl;
  _wa+= hl;
  m_word(xix-4)= wa;
  xiz= currb; //a͂߂āAb͖߂
  _hl= *(word*)m(xiy); xiy+= 4;
  curra= xiy;
  heighta= hl;
  _hl|= bc;
  if((short)hl<0) goto oryloop;
  goto orfinish;
orybnext://b
  heighta-= bc;
  _wa+= bc;
  m_word(xix-4)= wa;
  xiy= curra; //b͂߂āAa͖߂
  _bc= *(word*)m(xiz); xiz+= 4;
  currb= xiz;
  heightb= bc;
  _hl|= bc;
  if((short)hl<0) goto oryloop;
  goto orfinish; //
oryabnext://ab
  _wa+= bc;
  m_word(xix-4)= wa;
  _hl= *(word*)m(xiy); xiy+= 4;
  _bc= *(word*)m(xiz); xiz+= 4;
  curra= xiy;
  currb= xiz;
  heighta= hl;
  heightb= bc;
  _hl|= bc;
  if((short)hl<0) goto oryloop;
//goto orfinish;
// ㏈
orfinish:
  xwa= 0x10000;
  m_word(xde-4)= xwa; m_word(xde-2)= xwa>>16;
//]Ȋmۃ
  xde-= areat;
  xwa= areat;
  _hl= gcObjRealloc((void**)&xwa, (long*)&xde, 16);
  _hl= 0;
  *(dword*)prgnt= areat;
  return(short)hl;
// or x core
// assign a: ix=-1-Xa, pointer:xiy, counter:bc
//        b: hl=-1-Xb, pointer:xiz, counter:qhl
//        t: wa=Xlast, pointer:xde
//      out: xiy, xiz, xde, bc==0
// not used: qwa, qbc, qix
// entry point: orx00, exit to orxend
orx0001:// start-next Xb
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= hl;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
orx01:  
  if((short)ix>=(short)hl) goto orx0111;
// end-next-check Xb
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= hl;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  qhl--; if(qhl!=0) goto orx00;
  xiz-= 2;
orx0100e:// XaRs[
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc+= bc;
  _bc-= 1;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
  goto orxend;
orx1000:// end-check-next Xa
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= ix;
  _bc-= 1; //tO𓮂
  if((word)bc==0) goto orx1000e;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
orx00:  
  if((short)ix<(short)hl) goto orx0001;
// start-next Xa
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _wa= ix;
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  goto orx10;
orx0111:// next Xa
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
orx11:
  if((short)hl>=(short)ix) goto orx1110;
// next-check Xa
  _ix-= (mem= xiy,xiy+= 2,m_word(mem));
  _bc--; if((word)bc!=0) goto orx01;
  xiy-= 2;
orx1101e:// XbRs[
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc= 0xffff;
  _bc+= qhl;
  if((word)bc==0) goto orxend;
  _bc+= bc;
  xhl= xiz;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiz= xhl;
  goto orxend;
orx1110:// check-next Xb
  qhl-= 1;
  if(qhl==0) goto orx1110e;
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
orx10:
  if((short)hl<(short)ix) goto orx1000;
// next Xb
  _hl-= (mem= xiz,xiz+= 2,m_word(mem));
  goto orx11;
orx1000e:// XbRs[
  _wa-= hl;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc= qhl;
  _bc+= bc;
  _bc-= 1;
  xhl= xiz;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiz= xhl;
  goto orxend;
orx1110e:// XaRs[
  _wa-= ix;
  (mem= xde,xde+= 2,m_word(mem))= wa;
  _bc-= 1;
  if((word)bc==0) goto orxend;
  _bc+= bc;
  xhl= xiy;
  do { *(word*)m(xde)= *(word*)m(xhl);
       xde+= 2; xhl+= 2; } while(--_bc, (word)bc);
  xiy= xhl;
  goto orxend;
};
